#### <sub><sup><a name="v0740-note-1" href="#v0740-note-1">:link:</a></sup></sub> feature

* You can now [configure resource types in your pipeline](https://concourse-ci.org/resource-types.html) rather than redeploying your workers with additional resource types. This should make it much easier to use the community resources that people have built!
  
  
#### <sub><sup><a name="v0740-note-2" href="#v0740-note-2">:link:</a></sup></sub> feature

* Autoscroll on a build page is back and is now implemented in a way that doesn't kill the browser when you have many build events.
  
  
#### <sub><sup><a name="v0740-note-3" href="#v0740-note-3">:link:</a></sup></sub> feature

* If the Docker image you specify in the [**`image_resource`**](https://concourse-ci.org/tasks.html#image_resource) section of your task has a custom user then we will now respect that when running the task. This user will also be used when hijacking in to a build container.
  
  
#### <sub><sup><a name="v0740-note-4" href="#v0740-note-4">:link:</a></sup></sub> feature

* Hijacked connections will no longer cause connection timeouts at interim load balancers if there is no input or output.
  
  
#### <sub><sup><a name="v0740-note-5" href="#v0740-note-5">:link:</a></sup></sub> feature

* The pipeline graph rendering now has large portions of the computation cached. This should provide a significant speedup and decrease in CPU load when viewing a pipeline.
  
  
#### <sub><sup><a name="v0740-note-6" href="#v0740-note-6">:link:</a></sup></sub> feature

* We've made some tweaks to the ATC's build scheduling that should fix "deadlock" scenarios with serial groups.
  
  Previously, if a pipeline of "A -> B -> C" had all 3 jobs in a serial group, and the builds were enqueued in order of C, B, then A (manually), nothing could ever run, as the scheduling was based on the order of the builds being enqueued, and C would never be satisifed. This is now fixed by collecting inputs and then scheduling only once they're available, so that C never gets scheduled, and so A is able to be scheduled, followed by B, and then C.
  
  
#### <sub><sup><a name="v0740-note-7" href="#v0740-note-7">:link:</a></sup></sub> fix

* The icon font that was broken in Safari by v0.73.0 are now unbroken by v0.74.0.
  
  
#### <sub><sup><a name="v0740-note-8" href="#v0740-note-8">:link:</a></sup></sub> fix

* Interrupting a `fly execute` that was fetching outputs will no longer panic if you cancel it in the middle.
  
  
#### <sub><sup><a name="v0740-note-9" href="#v0740-note-9">:link:</a></sup></sub> feature

* If you try and trigger a build while you are not logged in then we'll now redirect you back to the build page you were on rather than the main pipeline page.
  
  
#### <sub><sup><a name="v0740-note-10" href="#v0740-note-10">:link:</a></sup></sub> feature

* The [Pool resource](https://github.com/concourse/pool-resource) will now ignore in-place modifications when working out if a log aquisition is still valid.
  
  
#### <sub><sup><a name="v0740-note-11" href="#v0740-note-11">:link:</a></sup></sub> feature

* [`fly` CLI](https://concourse-ci.org/fly.html) will now print the target it will be interacting with at the start of every command.
  
  
#### <sub><sup><a name="v0740-note-12" href="#v0740-note-12">:link:</a></sup></sub> breaking

* [`fly` CLI](https://concourse-ci.org/fly.html) default value of the `-t` flag has been removed. If you're using the VirtualBox distribution then you'll need to start logging in and supplying a target. This is to get people in this habit before they progress to a bigger deployment.
  
  
#### <sub><sup><a name="v0740-note-13" href="#v0740-note-13">:link:</a></sup></sub> feature

* [`fly` CLI](https://concourse-ci.org/fly.html) has a more sensible timeout and a better error message if it cannot reach the targeted Concourse.
  
  
#### <sub><sup><a name="v0740-note-14" href="#v0740-note-14">:link:</a></sup></sub> feature

* We bumped to Go 1.6. You should see absolutely no change.
  
  
