#### <sub><sup><a name="v0750-note-1" href="#v0750-note-1">:link:</a></sup></sub> deprecation, feature

* The [Semver resource](https://github.com/concourse/semver-resource) now creates a file called `version` containing the version number, making it consistent with other resources that provide a version.
  
  We still create `number` for backwards compatibility, but you should switch.
  
  
#### <sub><sup><a name="v0750-note-2" href="#v0750-note-2">:link:</a></sup></sub> deprecation, feature

* Specifying both [**`file`**](https://concourse-ci.org/task-step.html#task-step-file) and [**`config`**](https://concourse-ci.org/task-step.html#task-step-config) on a task step is now deprecated. You should receive warnings when running [`fly set-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-set-pipeline) and when running a task that specifies both.
  
  Instead, you should be specifying [**`params`**](https://concourse-ci.org/task-step.html#task-step-params), [**`input_mapping`**](https://concourse-ci.org/task-step.html#input_mapping), and [**`output_mapping`**](https://concourse-ci.org/task-step.html#output_mapping).
  
  
#### <sub><sup><a name="v0750-note-3" href="#v0750-note-3">:link:</a></sup></sub> feature

* [`fly` CLI](https://concourse-ci.org/fly.html) and the web UI now know their own version! We probably should have done this years ago. So `fly -v` now works instead of printing a shrugging emoticon, and the web UI now has the version at the bottom right (it even live updates, for all your CI monitors out there).
  
  In addition, `fly` will print a warning if the versions are slightly out of sync (patch release), and straight up prevent itself from running if they're significantly out of sync (i.e. minor or major).
  
  
#### <sub><sup><a name="v0750-note-4" href="#v0750-note-4">:link:</a></sup></sub> fix

* Tagged workers are now supported by [**`image_resource`**](https://concourse-ci.org/tasks.html#image_resource).
  
  
#### <sub><sup><a name="v0750-note-5" href="#v0750-note-5">:link:</a></sup></sub> feature

* The duration that containers stick around for after finishing is now configurable via new `atc.retention.*` BOSH properties (and corresponding flags to the ATC).
  
  
#### <sub><sup><a name="v0750-note-6" href="#v0750-note-6">:link:</a></sup></sub> feature

* [`fly intercept`](https://concourse-ci.org/builds.html#fly-intercept) now sorts its container list, which should aid in frustration with finding the container to intercept.
  
  
#### <sub><sup><a name="v0750-note-7" href="#v0750-note-7">:link:</a></sup></sub> feature

* [`fly containers`](https://concourse-ci.org/administration.html#fly-containers) now shows the TTL (as we've configured it) and validity (actual expiration, which counts down to 0) for each container. This will be useful to know which ones are sticking around because they failed, and which ones are sticking around because of a build that's running too frequently.
  
  
#### <sub><sup><a name="v0750-note-8" href="#v0750-note-8">:link:</a></sup></sub> feature

* `fly` learned the [`fly abort-build`](https://concourse-ci.org/builds.html#fly-abort-build) command, thanks to a pull request from @zachgersh.
  
  
#### <sub><sup><a name="v0750-note-9" href="#v0750-note-9">:link:</a></sup></sub> feature

* `fly` learned the [`fly trigger-job`](https://concourse-ci.org/managing-jobs.html#fly-trigger-job) command, thanks to a pull request from @aminjam.
  
  
#### <sub><sup><a name="v0750-note-10" href="#v0750-note-10">:link:</a></sup></sub> feature

* The [BOSH deployment resource](https://github.com/concourse/bosh-deployment-resource) now supports deploying to a director using UAA client ID/secret for auth.
  
  
#### <sub><sup><a name="v0750-note-11" href="#v0750-note-11">:link:</a></sup></sub> feature

* We've bumped the version of [Buildroot](https://buildroot.org/) that many of our resources are based on, which should bring in updated CA certificates and other miscellaneous things.
  
  
#### <sub><sup><a name="v0750-note-12" href="#v0750-note-12">:link:</a></sup></sub> fix

* Previously resources that had [**`params`**](https://concourse-ci.org/put-step.html#put-step-params) involving lists of objects would cause Concourse to blow up instead of working. It should now work.
  
  
