#### <sub><sup><a name="v110-note-1" href="#v110-note-1">:link:</a></sup></sub> feature

* Workers can now configure proxies to use for containers that are spun up on them.
  
  If you're using the [binaries](https://concourse-ci.org/install.html), all you have to do is set the standard `$http_proxy`, `$https_proxy`, and `$no_proxy` environment variables. There are also equivalent flags you can pass to `concourse worker`, which were added for discoverability's sake.
  
  If you're using BOSH, just set the `http_proxy_url`, `https_proxy_url`, and `no_proxy` properties on the `groundcrew` job.
  
  
#### <sub><sup><a name="v110-note-2" href="#v110-note-2">:link:</a></sup></sub> feature

* A task's [**`run`**](https://concourse-ci.org/tasks.html#task-run) can now specify the working directory by setting [**`run.dir`**](https://concourse-ci.org/tasks.html#task-run-dir).
  
  
#### <sub><sup><a name="v110-note-3" href="#v110-note-3">:link:</a></sup></sub> feature

* [`fly`](https://concourse-ci.org/fly.html) learned the [`fly targets`](https://concourse-ci.org/fly.html#fly-targets) command, which, surprise surprise, lists the currently saved targets.
  
  
#### <sub><sup><a name="v110-note-4" href="#v110-note-4">:link:</a></sup></sub> fix

* The `blackbox` job in the BOSH release will now once again emit logs, by autodiscovering them from `/var/vcap/sys/log/*/*.log`.
  
  
#### <sub><sup><a name="v110-note-5" href="#v110-note-5">:link:</a></sup></sub> fix

* Fixed rendering of leading whitespace on lines of output in build logs.
  
  
#### <sub><sup><a name="v110-note-6" href="#v110-note-6">:link:</a></sup></sub> fix

* Fixed the scrolling behavior of the pipelines sidebar list to not cut off the last couple of entries.
  
  
#### <sub><sup><a name="v110-note-7" href="#v110-note-7">:link:</a></sup></sub> fix

* The [Docker Image resource](https://github.com/concourse/docker-image-resource) is now durable to resource images that do not contain a `/etc/password` file.
  
  
#### <sub><sup><a name="v110-note-8" href="#v110-note-8">:link:</a></sup></sub> fix

* Previously renaming a pipeline made bad things happen to the automatic resource checking and scheduling for said pipeline. Instead of doing this it now renames the pipeline *and* the pipeline continues to work.
  
  
#### <sub><sup><a name="v110-note-9" href="#v110-note-9">:link:</a></sup></sub> fix

* Previously a [`put` step](https://concourse-ci.org/put-step.html) occurring at the start of the plan would not have its source directory created (as there were no artifacts), which would cause some resources to break. We now ensure this directory exists.
  
  
#### <sub><sup><a name="v110-note-10" href="#v110-note-10">:link:</a></sup></sub> fix

* You can now scroll up more easily when viewing a finished build.  [You are all free now!](https://www.youtube.com/watch?v=_yYS0ZZdsnA)
  
  
#### <sub><sup><a name="v110-note-11" href="#v110-note-11">:link:</a></sup></sub> feature

* You can now run `fly help` and it'll show its help text instead of "unknown command."
  
  
#### <sub><sup><a name="v110-note-12" href="#v110-note-12">:link:</a></sup></sub> fix

* Previously if you had an entry in [Resource Types](https://concourse-ci.org/resource-types.html) and [Resources](https://concourse-ci.org/resources.html) with the same name the ATC catch on fire. It now doesn't.
  
  
#### <sub><sup><a name="v110-note-13" href="#v110-note-13">:link:</a></sup></sub> fix

* Users who are present in more than 30 GitHub organizations and/or teams can now authorize with Concourse. You should be rewarded for your popularity.
  
  
#### <sub><sup><a name="v110-note-14" href="#v110-note-14">:link:</a></sup></sub> fix

* Piping input into [`fly intercept`](https://concourse-ci.org/builds.html#fly-intercept) will now send an EOF when the input is exhausted (e.g. `echo foo | fly intercept ... cat`).
  
  
