#### <sub><sup><a name="v130-note-1" href="#v130-note-1">:link:</a></sup></sub> feature, breaking

* We have switched Garden backends to [Garden runC](https://github.com/cloudfoundry-incubator/garden-runc-release). This new [runC](https://runc.io/)-based backend has proven in our testing to be far more portable, allowing our binaries to work on just about any stack that's using a recent enough Linux kernel (3.19+).
  
  > **warning:** As part of this upgrade, your existing workers will need to be recreated.
  > 
  > With BOSH, you can do this with `bosh deploy --recreate` when deploying the new releases.
  > 
  > For the binaries, you'll need to stop the old worker, nuke the `--work-dir`, and then start the new one.
  > 
  > 
  In addition, we now explicitly manage all aspects of container images. This should dramatically reduce disk usage on your workers, as there's no longer a redundant copy from importing the image into Garden's graph, as long as you're using [**`image_resource`**](https://concourse-ci.org/tasks.html#image_resource). This also means we're now using `btrfs` for the whole stack, which makes running Docker in Concourse tasks much easier.
  
  As part of this, the binary distribution no longer supports `image` in the task config. Supporting it has always been a portability nightmare, and we've been discouraging use of `image` for some time now.
  
  
#### <sub><sup><a name="v130-note-2" href="#v130-note-2">:link:</a></sup></sub> feature

* Jobs can now be configured with [**`build_logs_to_retain`**](https://concourse-ci.org/jobs.html#job-build-logs-to-retain), which is a number indicating how many builds for which to keep the build output. All build logs except for the most recent N builds will be reaped. You can flip this on for already-existing jobs with thousands of builds and we'll slowly reap them in batches.
  
  
#### <sub><sup><a name="v130-note-3" href="#v130-note-3">:link:</a></sup></sub> feature

* A [`task` step](https://concourse-ci.org/task-step.html) in a plan can now be configured with an [**`image`**](https://concourse-ci.org/task-step.html#task-step-image) field specifying an artifact source to use. This allows for build-and-test flows, where your pipeline produces an image and then propagates the exact image to a task that uses it as its rootfs.
  
  
#### <sub><sup><a name="v130-note-4" href="#v130-note-4">:link:</a></sup></sub> feature

* [`fly volumes`](https://concourse-ci.org/administration.html#fly-volumes) now includes much more information about each volume, including its disk usage. This should help track down what's using so much disk, and whether you really just need more space to accomodate your workload.
  
  
#### <sub><sup><a name="v130-note-5" href="#v130-note-5">:link:</a></sup></sub> feature

* A [`hg` resource](https://github.com/concourse/hg-resource) is now included as part of the core distribution.
  
  
#### <sub><sup><a name="v130-note-6" href="#v130-note-6">:link:</a></sup></sub> feature

* When a build is stuck "waiting for a suitable set of input versions", it will now show what input it cannot find versions for, and why.
  
  
#### <sub><sup><a name="v130-note-7" href="#v130-note-7">:link:</a></sup></sub> feature

* Previously workers could end up with very poor balancing of containers, in the worst case resulting in one worker handling the bulk of the resource checking load. We now balance checking across workers over time, by only reusing the check containers for up to an hour.
  
  
#### <sub><sup><a name="v130-note-8" href="#v130-note-8">:link:</a></sup></sub> feature

* The ATC itself can now be configured to listen with TLS, rather than relying on an upstream component like HAProxy or an ELB for SSL termination.
  
  This also means the ATC can handle HTTP/2 traffic, thanks to Go's magic `net/http` package. We've seen noticeable speed boosts in the web UI from this alone.
  
  When TLS is configured the ATC will redirect any non-HTTPS `GET` and `HEAD` requests to HTTPS.
  
  
#### <sub><sup><a name="v130-note-9" href="#v130-note-9">:link:</a></sup></sub> feature

* In addition to HTTP/2, we've done some optimizations that make the pipeline UI much faster and more responsive.
  
  
#### <sub><sup><a name="v130-note-10" href="#v130-note-10">:link:</a></sup></sub> fix

* [`fly intercept`](https://concourse-ci.org/builds.html#fly-intercept)'s help text now indicates that you can run an arbitrary command.
  
  
#### <sub><sup><a name="v130-note-11" href="#v130-note-11">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) now includes `branches` and `tags` in its metadata for each commit.
  
  
#### <sub><sup><a name="v130-note-12" href="#v130-note-12">:link:</a></sup></sub> fix

* Previously the [`time` resource](https://github.com/concourse/time-resource) would accidentally report two versions within the boundary of a time range configured with `start` and `stop`. This has been fixed.
  
  
#### <sub><sup><a name="v130-note-13" href="#v130-note-13">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) can now be configured with SSL CA certs to trust when communicating with the registry. This allows you to use private registries securely, rather than listing the address as insecure.
  
  
#### <sub><sup><a name="v130-note-14" href="#v130-note-14">:link:</a></sup></sub> fix

* The [`git` resource](https://github.com/concourse/git-resource) will now detect the full history of tags when configured with `tag_filter`, rather than just the latest one.
  
  
#### <sub><sup><a name="v130-note-15" href="#v130-note-15">:link:</a></sup></sub> feature

* All core resources now include `bash` in their image, which should make hijacking more pleasant. We also stripped out extra stuff from some resources, so on the whole the resource images should be a bit smaller.
  
  
#### <sub><sup><a name="v130-note-16" href="#v130-note-16">:link:</a></sup></sub> feature

* We've bumped all core images to [Buildroot](https://buildroot.org) v2016.05, and are now continously integrating with Buildroot.
  
  
#### <sub><sup><a name="v130-note-17" href="#v130-note-17">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) can now be configured to *NOT* skip commits with `[ci skip]` in them, thanks to a PR from @zachgersh and @ryanmoran. This is useful when you're pointing at commits of an external repo with an unrelated CI.
  
  
#### <sub><sup><a name="v130-note-18" href="#v130-note-18">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource), [`s3` resource](https://github.com/concourse/s3-resource), and [`semver` resource](https://github.com/concourse/semver-resource) now support basic auth when talking to Git repos, thanks to PRs from @MatthiasWinzeler and @JamesClonk.
  
  
#### <sub><sup><a name="v130-note-19" href="#v130-note-19">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) can now be configured with a registry mirror, thanks to a PR from @gregarcara.
  
  
