#### <sub><sup><a name="v260-note-1" href="#v260-note-1">:link:</a></sup></sub> feature

* Workers will now, by default, wait for builds to finish before exiting. This will make it safer to perform a rolling update of a Concourse cluster.
  
  If you're running a BOSH deployment, this feature will just start happening automatically. If you're running the binary distribution or Docker, you'll need to invoke `land-worker` (for a temporary in-place update, i.e. preserving containers and volumes) or `retire-worker` (for a permanent exit) to initiate draining, and then wait for the worker process to exit.
  
  More docs on this are forthcoming; this release was expedited by the [`time` resource](https://github.com/concourse/time-resource) bug, so docs are sparse at the moment.
  
  
#### <sub><sup><a name="v260-note-2" href="#v260-note-2">:link:</a></sup></sub> feature

* Workers that have not heartbeated in a while will now enter a `stalled` state rather than just disappearing. This should improve resilience to network blips and makes the worker lifecycle much more explicit, allowing us to distinguish between accidentally-unavailable workers and intentionally-removed workers. This way we can continue to retry and wait for the worker to return.
  
  New workloads will not be placed on `stalled` workers. Stalled workers that will not be coming back can be cleaned up with the new command, [`fly prune-worker`](https://concourse-ci.org/administration.html#fly-prune-worker).
  
  
#### <sub><sup><a name="v260-note-3" href="#v260-note-3">:link:</a></sup></sub> fix

* The [`time` resource](https://github.com/concourse/time-resource) did not know to compare years. Yep. Pretty silly. So any interval triggers stopped triggering. Time is hard.
  
  
#### <sub><sup><a name="v260-note-4" href="#v260-note-4">:link:</a></sup></sub> feature

* Fly learned the [`fly logout`](https://concourse-ci.org/fly.html#fly-logout) command, which can be used to forget a target and its token. This is thanks to a PR by @mkreibe!
  
  
#### <sub><sup><a name="v260-note-5" href="#v260-note-5">:link:</a></sup></sub> feature

* Fly learned the [`fly validate-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-validate-pipeline) command, which can be used to...validate a pipeline. It does this without needing an external server, either, making it handy for quick local verification or automated testing.
  
  This was a PR submitted by @jmcarp - thanks!
  
  
#### <sub><sup><a name="v260-note-6" href="#v260-note-6">:link:</a></sup></sub> feature

* Previously if you configured a job with multiple [`get` step](https://concourse-ci.org/get-step.html)s with the same name, the job would never be able to schedule. @cnelson did a PR to add a validation for this borked configuration - thanks!
  
  
#### <sub><sup><a name="v260-note-7" href="#v260-note-7">:link:</a></sup></sub> feature

* [`fly` CLI](https://concourse-ci.org/fly.html) should now support colors on Windows, thanks to a PR from @alex-slynko!
  
  
#### <sub><sup><a name="v260-note-8" href="#v260-note-8">:link:</a></sup></sub> feature

* The BOSH release was changed to default Baggageclaim to consuming (disk size - 5GB), which was all fine and good until your disk was <= 5GB, which caused it to fail. It will now use the full 5GB. Though...you should probably just get more GBs.
  
  
#### <sub><sup><a name="v260-note-9" href="#v260-note-9">:link:</a></sup></sub> feature

* Resource checking can now be directed at a tagged worker by specifying [**`tags`**](https://concourse-ci.org/resources.html#resource-tags) on the resource.
  
  
