#### <sub><sup><a name="v271-note-1" href="#v271-note-1">:link:</a></sup></sub> fix, security

* If you have a team configured with Generic oAuth, you'll want to upgrade to this release ASAP. Previously a check was missed for this provider in particular that allows users to obtain a token.
  
  We have fixed this *hard* by making it impossible to forget to update that code path in future PRs. Providers now have a full interface to fill out, rather than having code that implements them strewn throughout the codebase.
  
  
#### <sub><sup><a name="v271-note-2" href="#v271-note-2">:link:</a></sup></sub> fix, security

* This fix closes a CSRF security hole in the ATC API. Previously someone could fool you into clicking a link that executes destructive AJAX requests on your behalf. This was possible because the ATC API permits cookie-based auth so that JavaScript EventSource requests (used for streaming build logs) could be authorized.
  
  
#### <sub><sup><a name="v271-note-3" href="#v271-note-3">:link:</a></sup></sub> fix, security

* A few headers for security hygiene are now configured on the ATC: `X-XSS`, `X-Frame-Options` (configurable; default off so your CI displays will still work), and a few parameters on the cookies that the ATC uses.
  
  
#### <sub><sup><a name="v271-note-4" href="#v271-note-4">:link:</a></sup></sub> fix, security

* Previously the `fly_local_port` query param used in the [`fly login`](https://concourse-ci.org/fly.html#fly-login) flow for oAuth could be munged in such a way to send the token to an arbitrary website. This meant that someone could fool you into clicking a link that sent a valid token to themselves. This is now fixed by validating that the query param is numeric.
  
  
#### <sub><sup><a name="v271-note-5" href="#v271-note-5">:link:</a></sup></sub> fix, security

* Previously the `redirect` query param used in the `redirect` flow for oAuth could be set to any URL, sending you there after you log in to your oauth provider. Now Concourse verifies that the URL is relative to your Concourse domain, and returns a 400 otherwise.
  
  
#### <sub><sup><a name="v271-note-6" href="#v271-note-6">:link:</a></sup></sub> fix

* Fixed a memory leak in the TSA. The leak occurred every time a connection was made to Garden or Baggageclaim on a forwarded worker. This took us a while to notice and fix because we're already running the code targeting v2.8.0, which includes a large refactor which results in fewer network calls. Thanks to everyone who helped us dig into this!
  
  
#### <sub><sup><a name="v271-note-7" href="#v271-note-7">:link:</a></sup></sub> fix

* The Darwin binary no longer checks that you're running it as the `root` user. This was initially added because in principle you can run tasks as particular users, but this feature is not well-supported yet, so it's easier to just run the binary as a user that can e.g. talk to Xcode.
  
  We'll add this check back once we properly support running tasks as custom users.
  
  
#### <sub><sup><a name="v271-note-8" href="#v271-note-8">:link:</a></sup></sub> feature

* The TSA can now be configured to register against multiple ATCs, rather than just one URL. It will pick a random ATC every time it heartbeats.
  
  
