> **warning:** Users upgrading to v3.10.0 with BOSH have reported issues where baggageclaim will not start after the upgrade. This issue has been reported and fixed for future versions of Concourse. In the meantime, you can workaround the problem by using the workaround described in [#2125](https://github.com/concourse/concourse/pull/2125#issuecomment-378711617)
> 
> 
 #### <sub><sup><a name="v3100-note-1" href="#v3100-note-1">:link:</a></sup></sub> breaking

* This release involves a worker protocol version bump, from `1.3` to `2.0`, and also switches the default baggageclaim driver back to `btrfs`. Read on for more information!
  
  We recommend spinning up a new pool of [`worker` node](https://concourse-ci.org/concourse-worker.html)s, upgrading your [`web` node](https://concourse-ci.org/concourse-web.html)s, and then removing the old workers. Otherwise your workers may get swarmed with containers, if only one `2.0` worker is added at a time with the web nodes already upgraded.
  
  


#### <sub><sup><a name="v3100-note-2" href="#v3100-note-2">:link:</a></sup></sub> feature, breaking

* The `concourse` worker commands can now be pointed at *multiple* [TSA](https://concourse-ci.org/architecture.html#component-tsa) addresses, rather than one, so that it can retry against a random node each time. As part of this, we've removed the `--tsa-port` flag and changed `--tsa-host` to instead take a `host:port`. (Because [TECHNICALLY](images/technically.gif), they could be on different ports.)
  
  
#### <sub><sup><a name="v3100-note-3" href="#v3100-note-3">:link:</a></sup></sub> feature

* We've revamped how [`fly execute`](https://concourse-ci.org/running-tasks.html#fly-execute) gets its inputs and outputs to/from the build, so that configuring the [ATC](https://concourse-ci.org/architecture.html#component-atc) with an external URL is no longer required. See concourse/concourse#2069 for the nitty-gritty.
  
  
#### <sub><sup><a name="v3100-note-4" href="#v3100-note-4">:link:</a></sup></sub> feature, breaking

* We've switched back to `btrfs` as the default driver. We switched away in [**v3.1.0**](https://github.com/concourse/concourse/releases/tag/v3.1.0) in the midst of a ton of stability issues, which we have think we've fixed in [**v3.9.0**](https://github.com/concourse/concourse/releases/tag/v3.9.0).
  
  This resolves a long-standing performance issue when using privileged tasks or resource types (like the [`docker-image` resource](https://github.com/concourse/docker-image-resource)). For more information, see concourse/concourse#1404 and concourse/concourse#1966.
  
  Be sure to use the latest possible kernel version so that you have a `btrfs` with the latest fixes. We suspect that this will still be an occasional issue, though far less frequent.
  
  
#### <sub><sup><a name="v3100-note-5" href="#v3100-note-5">:link:</a></sup></sub> fix

* Previously, [**`tags`**](https://concourse-ci.org/resource-types.html#resource-type-tags) on a resource type didn't get no respect. They are now respected.
  
  
#### <sub><sup><a name="v3100-note-6" href="#v3100-note-6">:link:</a></sup></sub> fix

* Fixed an [ATC](https://concourse-ci.org/architecture.html#component-atc) crash that would occur when a [`task` step](https://concourse-ci.org/task-step.html) errored with the next step using an [`attempts` step modifier](https://concourse-ci.org/attempts-step-modifier.html).
  
  
#### <sub><sup><a name="v3100-note-7" href="#v3100-note-7">:link:</a></sup></sub> feature

* The `concourse` binary (and Docker image) now supports a `quickstart` command, which will spin up an itty bitty Concourse cluster with a single worker.
  
  
#### <sub><sup><a name="v3100-note-8" href="#v3100-note-8">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now supports pushing multiple tags, thanks to a combined effort of @gcmalloc and @jerith!
  
  
#### <sub><sup><a name="v3100-note-9" href="#v3100-note-9">:link:</a></sup></sub> feature

* When the [ATC](https://concourse-ci.org/architecture.html#component-atc) is streaming data between workers, the stream will now be `gzip`-compressed, which should speed things up quite a bit. (This is what caused the worker version bump to `2.0`.)
  
  
#### <sub><sup><a name="v3100-note-10" href="#v3100-note-10">:link:</a></sup></sub> feature, security

* The [ATC](https://concourse-ci.org/architecture.html#component-atc) now requires TLS v1.2+ and a [stricter set of cipher suites](https://github.com/concourse/atc/blob/ed08aa96b357a19a6dca08608108cb6e07735aa7/atccmd/command.go#L703-L707). Say that five times fast!
  
  
#### <sub><sup><a name="v3100-note-11" href="#v3100-note-11">:link:</a></sup></sub> fix

* Concourse now supports the newer `umask`-hardened BOSH stemcells (v3541.x).
  
  
#### <sub><sup><a name="v3100-note-12" href="#v3100-note-12">:link:</a></sup></sub> fix

* Fixed a botched `bash`ism that led to the [`docker-image` resource](https://github.com/concourse/docker-image-resource) to exit early on certain environments (more info [here](https://github.com/concourse/docker-image-resource/issues/170)).
  
  
#### <sub><sup><a name="v3100-note-13" href="#v3100-note-13">:link:</a></sup></sub> fix

* Cleaned up a noisy PostgreSQL error that would occur on start when checking for the legacy `migration_version` table.
  
  
#### <sub><sup><a name="v3100-note-14" href="#v3100-note-14">:link:</a></sup></sub> fix

* Fixed a UI glitch that caused the last line to be misaligned with the timestamps if it had no trailing linebreak.
  
  
