> **warning:** v3.11.0 has a memory leak issue in the ATC/web server concourse/concourse#2165. The severity of the memory leak will be different based on the size of your deployment and the types of workloads you run on it.
> 
> 
 #### <sub><sup><a name="v3110-note-1" href="#v3110-note-1">:link:</a></sup></sub> fix, breaking

* The [`git` resource](https://github.com/concourse/git-resource) will no longer have tags present in the fetched repo, thanks to a PR by @benmoss.
  
  They are now cleared out after the fetch, because the state of all tags is prone to change after the initial fetch, as the resource's source of truth is *commits*. So after the fetch, the cache would have an out-of-date view of the tags, which could lead to problems when pushing.
  
  


#### <sub><sup><a name="v3110-note-2" href="#v3110-note-2">:link:</a></sup></sub> fix

* Fixed a bug in the BOSH release that prevented the [`worker` node](https://concourse-ci.org/concourse-worker.html)s from starting in a fresh deploy. Sorry about that. Thanks @z4ce for the PR!
  
  
#### <sub><sup><a name="v3110-note-3" href="#v3110-note-3">:link:</a></sup></sub> feature

* The `/dashboard` page looks better on phones now.
  
  
#### <sub><sup><a name="v3110-note-4" href="#v3110-note-4">:link:</a></sup></sub> feature

* The `/dashboard` page makes way fewer requests now, so it's a lot faster to load and more efficient to periodically refresh.
  
  
#### <sub><sup><a name="v3110-note-5" href="#v3110-note-5">:link:</a></sup></sub> feature

* The [`fly builds`](https://concourse-ci.org/builds.html#fly-builds) command can now filter by team (`-t`) or pipeline (`-p`), thanks to a PR by @andrewedstrom!
  
  
#### <sub><sup><a name="v3110-note-6" href="#v3110-note-6">:link:</a></sup></sub> fix

* Fixed a couple migrations that assumed a `public` schema. Thanks to @vganoradg for the PR!
  
  
#### <sub><sup><a name="v3110-note-7" href="#v3110-note-7">:link:</a></sup></sub> fix

* [`fly` CLI](https://concourse-ci.org/fly.html) will no longer repeatedly detonate when given an invalid token during [`fly login`](https://concourse-ci.org/fly.html#fly-login).
  
  
#### <sub><sup><a name="v3110-note-8" href="#v3110-note-8">:link:</a></sup></sub> feature

* There's a new credential manager in town for AWS's newly-launched [Secrets Manager](https://aws.amazon.com/secrets-manager/) (not to be confused with [Systems Manager](https://aws.amazon.com/documentation/systems-manager/), which is also used for managing secrets). Thanks @x6j8x for the PR!
  
  We realize that we now have two undocumented credential managers, one called AWS SSM and one called AWS SM. We like to call this "hard mode". (Sorry, we'll backfill docs soon.)
  
  
#### <sub><sup><a name="v3110-note-9" href="#v3110-note-9">:link:</a></sup></sub> feature

* The [Vault credential manager](https://concourse-ci.org/vault-credential-manager.html) can now be configured with a `--vault-auth-backend-max-ttl`, after which it will force a re-login. Thanks @baptiste-bonnaudet for the PR!
  
  
#### <sub><sup><a name="v3110-note-10" href="#v3110-note-10">:link:</a></sup></sub> feature

* The [Vault credential manager](https://concourse-ci.org/vault-credential-manager.html) will now retry with exponential backoff when logging in, rather than retrying every second.
  
  
#### <sub><sup><a name="v3110-note-11" href="#v3110-note-11">:link:</a></sup></sub> fix

* The [`time` resource](https://github.com/concourse/time-resource) will now correctly handle a tricky configurations that span multiple days (e.g. 10AM - 5AM), thanks to a PR by @jleben!
  
  
#### <sub><sup><a name="v3110-note-12" href="#v3110-note-12">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) will now make the commit message accessible under `.git/commit_message`, thanks to a PR by @elgohr!
  
  
#### <sub><sup><a name="v3110-note-13" href="#v3110-note-13">:link:</a></sup></sub> feature

* The [`web` node](https://concourse-ci.org/concourse-web.html) can now be configured with `--cookie-secure` to force `secure: true` on its cookies. Thanks for the PRs, @jmcarp!
  
  
#### <sub><sup><a name="v3110-note-14" href="#v3110-note-14">:link:</a></sup></sub> feature

* The [`github-release` resource](https://github.com/concourse/github-release-resource) now supports a `tag_filter` configuration for matching arbitrary semver tags, thanks to a PR from @jmcarp!
  
  
#### <sub><sup><a name="v3110-note-15" href="#v3110-note-15">:link:</a></sup></sub> fix

* Added a missing property to the BOSH release for configuring a CA cert for [Generic oAuth](https://concourse-ci.org/generic-oauth.html). Thanks for the PR, @youngm!
  
  
#### <sub><sup><a name="v3110-note-16" href="#v3110-note-16">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now supports configuring `aws_session_token`, thanks to a PR by @itsdalmo!
  
  
#### <sub><sup><a name="v3110-note-17" href="#v3110-note-17">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now has yet another new param, `cache_from`, thanks to a PR by @dhinus!
  
  This new param is like `load_bases` except everything loaded will also be used as a cache during the build.
  
  
#### <sub><sup><a name="v3110-note-18" href="#v3110-note-18">:link:</a></sup></sub> fix

* The [`git` resource](https://github.com/concourse/git-resource) will now recover from a deleted tag when configured with `tag_filter`, thanks to a PR by @ljfranklin!
  
  
#### <sub><sup><a name="v3110-note-19" href="#v3110-note-19">:link:</a></sup></sub> feature

* [`fly validate-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-validate-pipeline) with `--strict` will now be more strict with your YAML, thanks to a PR by @aeijdenberg!
  
  
#### <sub><sup><a name="v3110-note-20" href="#v3110-note-20">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now supports `verbose: true`, which will tell the CLI to dump trace logs to the output. Thanks for the PR, @JohannesRudolph!
  
  
#### <sub><sup><a name="v3110-note-21" href="#v3110-note-21">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now supports a `target_name` param for specifying the target to build in a multi-stage `Dockerfile`. Thanks to @irfanhabib for the PR!
  
  
#### <sub><sup><a name="v3110-note-22" href="#v3110-note-22">:link:</a></sup></sub> feature

* The BOSH release now bakes in the glue code for use with [BOSH Backup and Restore](https://github.com/cloudfoundry-incubator/bosh-backup-and-restore), thanks to a PR by @rkoster!
  
  
#### <sub><sup><a name="v3110-note-23" href="#v3110-note-23">:link:</a></sup></sub> feature

* The [`fly set-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-set-pipeline) command can now be given `--no-color` flag to strip out the color from the diffs. Instead of using color, `+` and `-` will be at the start of added and removed lines.
  
  
#### <sub><sup><a name="v3110-note-24" href="#v3110-note-24">:link:</a></sup></sub> feature

* Now that we're building with Go 1.10+, [`fly` CLI](https://concourse-ci.org/fly.html) will respect socks5 proxies configured via the "standard" `http_proxy`/`https_proxy` env vars.
  
  
