> **warning:** A bug was introduced in `build-reaper` under ATC/web that causes old build logs to accumulate in Concourse (concourse/concourse#2187).
> 
> 
 > **warning:** **Jun 1, 2018** A bug in Chrome 67 causes it to crash when loading the Concourse UI. At the time of this notice, the dev/canary versions of Google Chrome should work, as well as other browsers like Firefox and Safari. You can follow along the issue in concourse/concourse#2236
> 
> 
 #### <sub><sup><a name="v3120-note-1" href="#v3120-note-1">:link:</a></sup></sub> feature, breaking

* The [ATC](https://concourse-ci.org/architecture.html#component-atc) will now batch-delete containers and volumes, rather than making individual calls out to the worker. This is an incremental step towards concourse/concourse#1959 that should reduce the network/IO overhead on the ATC during garbage collection.
  
  > **warning:** This requires a new port to be reachable on the [`worker` node](https://concourse-ci.org/concourse-worker.html) from the [`web` node](https://concourse-ci.org/concourse-web.html): `7799`. This communication will go away once we fully complete parallel GC, as the workers will ask the web nodes what to delete instead.
  > 
  > 
  


#### <sub><sup><a name="v3120-note-2" href="#v3120-note-2">:link:</a></sup></sub> feature, breaking

* In [**v3.11.0**](https://github.com/concourse/concourse/releases/tag/v3.11.0) we changed the default behavior of the [`git` resource](https://github.com/concourse/git-resource) so that it does not fetch tags by default. In hindsight we should have been a bit more careful here, as many people depend on that behavior. We've decided to roll it back to fetching them by default, since in most cases (where tags are never deleted or re-pointed) it's not an issue to include them.
  
  To disable fetching of tags, configure `clean_tags: true` in [**`params`**](https://concourse-ci.org/get-step.html#get-step-params).
  
  Thanks for the PR, @mdomke!
  
  
#### <sub><sup><a name="v3120-note-3" href="#v3120-note-3">:link:</a></sup></sub> feature

* The [ATC](https://concourse-ci.org/architecture.html#component-atc) can now be configured with a global default [**`build_logs_to_retain`**](https://concourse-ci.org/jobs.html#job-build-logs-to-retain), thanks to a PR by @aeijdenberg! This is useful for operators who want more control over their database usage.
  
  A maximum value can also be configured to ensure users don't just set it to 9 trillion. The flags are `--default-build-logs-to-retain` and `--max-build-logs-to-retain`.
  
  
#### <sub><sup><a name="v3120-note-4" href="#v3120-note-4">:link:</a></sup></sub> fix

* Fixed a memory leak in the [TSA](https://concourse-ci.org/architecture.html#component-tsa) introduced in [**v3.11.0**](https://github.com/concourse/concourse/releases/tag/v3.11.0).
  
  
#### <sub><sup><a name="v3120-note-5" href="#v3120-note-5">:link:</a></sup></sub> feature

* The [`fly set-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-set-pipeline) command will no longer prompt `apply configuration?` if there are no changes to apply.
  
  
#### <sub><sup><a name="v3120-note-6" href="#v3120-note-6">:link:</a></sup></sub> feature

* There's a [`fly order-pipelines`](https://concourse-ci.org/managing-pipelines.html#fly-order-pipelines) command now, for setting the order of pipelines.
  
  
#### <sub><sup><a name="v3120-note-7" href="#v3120-note-7">:link:</a></sup></sub> feature

* A [`fly status`](https://concourse-ci.org/fly.html#fly-status) command has been added for checking whether or not you're logged in to the given target.
  
  
#### <sub><sup><a name="v3120-note-8" href="#v3120-note-8">:link:</a></sup></sub> feature

* When [`fly check-resource`](https://concourse-ci.org/managing-resources.html#fly-check-resource) fails, it'll bubble up the error message rather than just saying error code `500`.
  
  
#### <sub><sup><a name="v3120-note-9" href="#v3120-note-9">:link:</a></sup></sub> fix

* Work around an apparent regression/behavior change in recent versions of Chrome that prevented the pipeline UI jobs from being clickable.
  
  
#### <sub><sup><a name="v3120-note-10" href="#v3120-note-10">:link:</a></sup></sub> fix

* Fixed a corner case in error handling that could cause a lock to be held forever when detecting new versions of resource types. This could lead to things like builds stuck in "pending" state. Thanks to @SHyx0rmZ for the PR!
  
  
#### <sub><sup><a name="v3120-note-11" href="#v3120-note-11">:link:</a></sup></sub> fix

* When directed to the login page from the resource page, you will now be redirected back to where you were, rather than to the moon.
  
  
#### <sub><sup><a name="v3120-note-12" href="#v3120-note-12">:link:</a></sup></sub> fix

* The `concourse web` command is now capable of running the migration flags (`--current-db-version` and friends). It's still super janky (it'll run the [TSA](https://concourse-ci.org/architecture.html#component-tsa) alongside your...migrations), but hey, it runs them now.
  
  We'll probably clean this up in the future by having the migration stuff be a separate command instead.
  
  
#### <sub><sup><a name="v3120-note-13" href="#v3120-note-13">:link:</a></sup></sub> fix

* [`fly` CLI](https://concourse-ci.org/fly.html) will once again helpfully instruct you to log in rather than just saying `error: forbidden`.
  
  
#### <sub><sup><a name="v3120-note-14" href="#v3120-note-14">:link:</a></sup></sub> feature

* The BOSH release now supports properties for configuring the new AWS Secrets Manager credential backend. Thanks for the PR, @x6j8x!
  
  
#### <sub><sup><a name="v3120-note-15" href="#v3120-note-15">:link:</a></sup></sub> feature

* When a previously-created volume disappears from a worker and the ATC tries to use it, the error message will now include the worker name and the volume handle. Thanks for the PR, @rfliam!
  
  
#### <sub><sup><a name="v3120-note-16" href="#v3120-note-16">:link:</a></sup></sub> fix

* The [`fly check-resource`](https://concourse-ci.org/managing-resources.html#fly-check-resource) command will now fail more clearly when the resource's type is not found. Thanks to @jmcarp for the PR!
  
  
