> **warning:** A migration made it in to this release that slows down scheduling for pipelines with a bunch of version history. [**v3.14.1**](https://github.com/concourse/concourse/releases/tag/v3.14.1) has been released with the fix.
> 
> 
> **warning:** There is a known issue where you may see high CPU usage as a result of constant CredHub client connection concourse/concourse#2300
> 
> 
#### <sub><sup><a name="v3140-note-1" href="#v3140-note-1">:link:</a></sup></sub> feature

* You know that "home" icon that you click all the time and never fully know where it'll take you? Do you remember that empty feeling of not really knowing where "home" is anymore?
  
  WELL IT'S GONE NOW. And you know what's there instead? BREADCRUMBS. Breadcrumbs and memories.
  
  So now you can click the pipeline part to go to the pipeline, or the job part to go to the job.
  
  
#### <sub><sup><a name="v3140-note-2" href="#v3140-note-2">:link:</a></sup></sub> feature

* We've moved the pipeline groups navigation from the top bar to the pipeline page, where it's free to wrap around at its leisure (if there are many groups or looooooooooooooooooooong ones) rather than being constrained to the nav bar.
  
  
#### <sub><sup><a name="v3140-note-3" href="#v3140-note-3">:link:</a></sup></sub> feature

* Container and volume [Garbage Collection](https://concourse-ci.org/garbage-collection.html) will now be performed in parallel across the worker cluster.
  
  The ATC is still the source of truth for knowing *when* containers and volumes are to be removed, but will no longer be responsible for performing the actual "destroy" API calls. This should make large-scale Concourse deployments much more efficient, removing a ton of network and CPU overhead from the ATC.
  
  
#### <sub><sup><a name="v3140-note-4" href="#v3140-note-4">:link:</a></sup></sub> feature

* The Concourse BOSH release now includes Windows jobs: `baggageclaim-windows`, `houdini-windows`, and `worker-windows`. This means you can natively run a Windows worker via BOSH, equivalent in functionality to the Windows binaries!
  
  To see how to deploy it, consult the [`windows-worker.yml` ops file](https://github.com/concourse/concourse-bosh-deployment/blob/master/cluster/operations/windows-worker.yml).
  
  
#### <sub><sup><a name="v3140-note-5" href="#v3140-note-5">:link:</a></sup></sub> feature

* The dashboard will now indicate when a pipeline has a resource that is failing to check, by drawing a little orange triangle on the pipeline.
  
  
#### <sub><sup><a name="v3140-note-6" href="#v3140-note-6">:link:</a></sup></sub> feature

* The [`fly execute`](https://concourse-ci.org/running-tasks.html#fly-execute) command with `-j` will now use the job's pipeline's [**`resource_types`**](https://concourse-ci.org/pipelines.html#pipeline-resource-types). Huzzah!
  
  
#### <sub><sup><a name="v3140-note-7" href="#v3140-note-7">:link:</a></sup></sub> feature

* [`fly login`](https://concourse-ci.org/fly.html#fly-login) can now be invoked with `-b` to auto-launch a browser to do the oAuth dance, thanks to a PR by @novas0x2a!
  
  
#### <sub><sup><a name="v3140-note-8" href="#v3140-note-8">:link:</a></sup></sub> feature

* The [`s3` resource](https://github.com/concourse/s3-resource) now supports configuring an initial version & content, which can be useful for bootstrapping state. Thanks for the PR, @bandesz!
  
  
#### <sub><sup><a name="v3140-note-9" href="#v3140-note-9">:link:</a></sup></sub> feature

* The [**`webhook_token`**](https://concourse-ci.org/resources.html#resource-webhook-token) property can now be interpolated using a credential manager, thanks to a PR by @timrchavez!
  
  
#### <sub><sup><a name="v3140-note-10" href="#v3140-note-10">:link:</a></sup></sub> feature

* The [`pool` resource](https://github.com/concourse/pool-resource) now supports an atomic metadata update operation, thanks to a PR by @EleanorRigby!
  
  
#### <sub><sup><a name="v3140-note-11" href="#v3140-note-11">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) now has `git-crypt` v0.6.0, thanks to a PR by @gcapizzi!
  
  
#### <sub><sup><a name="v3140-note-12" href="#v3140-note-12">:link:</a></sup></sub> feature

* The Prometheus metric emitter has seen some spring cleaning, thanks to @databus23! See concourse/atc#274, concourse/atc#275, concourse/atc#276, and concourse/atc#278 for more details.
  
  
#### <sub><sup><a name="v3140-note-13" href="#v3140-note-13">:link:</a></sup></sub> fix

* A couple of the dashboard footer icons looked bloated in Firefox. They're all better now.
  
  
#### <sub><sup><a name="v3140-note-14" href="#v3140-note-14">:link:</a></sup></sub> fix

* We fixed GitHub issue concourse/concourse#2000, which is more of a moral victory than anything else. (The fix: the number in the `<title>` when viewing a one-off build in your browser is now consistent with the number reflected on the page.)
  
  
#### <sub><sup><a name="v3140-note-15" href="#v3140-note-15">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) now supports two new parameters: `submodule_recursive: false`, to disable the default recursive fetching, and `submodule_remote: true` to fetch submodules with `--remote`. Thanks to @ppaulweber for the PR!
  
  
#### <sub><sup><a name="v3140-note-16" href="#v3140-note-16">:link:</a></sup></sub> fix

* @SHyx0rmZ fixed up a few API endpoints so that they correctly return `Content-Type: application/json`. Thanks!
  
  
#### <sub><sup><a name="v3140-note-17" href="#v3140-note-17">:link:</a></sup></sub> fix

* Publishing draft releases with the [`github-release` resource](https://github.com/concourse/github-release-resource) will no longer error, thanks to a PR by @antonu17!
  
  
#### <sub><sup><a name="v3140-note-18" href="#v3140-note-18">:link:</a></sup></sub> fix

* Any errors when checking for a resource's *type* to have new versions will be bubbled up as resource checking errors. This includes failure to fetch credentials.
  
  
#### <sub><sup><a name="v3140-note-19" href="#v3140-note-19">:link:</a></sup></sub> feature

* The dashboard page now has "Dashboard" in the title.
  
  
#### <sub><sup><a name="v3140-note-20" href="#v3140-note-20">:link:</a></sup></sub> fix

* Fixed an "Aw, snap!" browser crash that affected some versions of Chrome when viewing the pipeline page.
  
  
#### <sub><sup><a name="v3140-note-21" href="#v3140-note-21">:link:</a></sup></sub> feature

* The ATC will no longer fail to start if configured with CredHub and CredHub isn't running. It'll just try and reach it later instead.
  
  
#### <sub><sup><a name="v3140-note-22" href="#v3140-note-22">:link:</a></sup></sub> fix

* The ATC will now fail gracefully early if no session signing key is specified, rather than failing ungracefully and late.
  
  In addition, one will be generated automatically if not given to `concourse web`. Don't do this forever, though, since users will be logged out whenever you restart the instance, and things won't work at all if you're running a cluster of many `web` nodes (they all need to have the same session signing key). Thanks for PRing this, @SHyx0rmZ!
  
  
#### <sub><sup><a name="v3140-note-23" href="#v3140-note-23">:link:</a></sup></sub> fix

* We accidentally kept the `quickstart` command hidden from the `concourse --help` dialogue. It's there now, thanks to @osis!
  
  
#### <sub><sup><a name="v3140-note-24" href="#v3140-note-24">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now supports client credentials -based auth, thanks to a PR by @jmcarp!
  
  
#### <sub><sup><a name="v3140-note-25" href="#v3140-note-25">:link:</a></sup></sub> fix

* The `concourse land-worker` command will no longer panic if invoked with no session signing key.
  
  
