> **warning:** This release has issues. Primarily with the BOSH distribution. You should probably just skip straight to [**v3.8.0**](https://github.com/concourse/concourse/releases/tag/v3.8.0).
> 
> 
#### <sub><sup><a name="v370-note-1" href="#v370-note-1">:link:</a></sup></sub> feature, security, breaking

* We've ripped out the old & janky PostgreSQL job from our Concourse BOSH release. You will have no choice but to bring your own PostgreSQL database.
  
  If you use the Concourse BOSH release and you haven't upgraded in a while, I'd suggest you check out the previous migration instructions from Concourse [**v3.5.0**](https://github.com/concourse/concourse/releases/tag/v3.5.0) and [**v3.6.0**](https://github.com/concourse/concourse/releases/tag/v3.6.0).
  
  
#### <sub><sup><a name="v370-note-2" href="#v370-note-2">:link:</a></sup></sub> feature, breaking

* We've changed how we develop database migrations, so as to support down migrations in the future. This will hopefully mean that if you upgrade Concourse and for whatever reason need to back out, you'll be able to, instead of being stuck on a (possibly broken) latest version.
  
  As part of this switch, we've also squashed our migrations into one big bang, which should also improve startup time for fresh installations. However, this means that **you must first upgrade to [**v3.6.0**](https://github.com/concourse/concourse/releases/tag/v3.6.0) before upgrading to [**v3.7.0**](https://github.com/concourse/concourse/releases/tag/v3.7.0)!**
  
  So, do that. You may need to anyway now that we've removed PostgreSQL (see previous note).
  
  
#### <sub><sup><a name="v370-note-3" href="#v370-note-3">:link:</a></sup></sub> feature, breaking

* There are new required manifest changes to deploy this release with BOSH.
  
  Our BOSH release used to have a few magical mystical packages called `generated_something`. These packages would generate a RSA key every time they compiled, in service of automagically wiring up security credentials so you didn't have to put them in your manifest.
  
  This approach was extremely clever and whoever came up with the idea was a downright genius, way ahead of their time.
  
  We've now collectively decided that the whole approach is stupid and redundant now that BOSH manifests can generate their own typed variables. It was fun while it lasted.
  
  **What you need to do for this change is described in concourse/concourse#1834**. You can consult [our changes to `manifests/single-vm.yml`](https://gist.github.com/vito/44cdf3aafcf4ba06349e24e8c21135eb) for reference.
  
  As an alternative to hand-editing your manifest, the next release note may pique your interest.
  
  
#### <sub><sup><a name="v370-note-4" href="#v370-note-4">:link:</a></sup></sub> feature

* We have started dusting off [`concourse-deployment`](https://github.com/concourse/concourse-deployment) and using it as a central location for Concourse BOSHy deployment goodness. We now use it for our production deployment, as well as a few testing environments.
  
  
#### <sub><sup><a name="v370-note-5" href="#v370-note-5">:link:</a></sup></sub> feature

* We are now openly gathering feedback on one of our worst-kept-secrets: the Concourse dashboard view. You can access it by visiting `/beta/dashboard`.
  
  In this version of Concourse, we've tweaked some of the visual elements of the dashboard to make it more readible for installations with multiple teams. We've also fixed some of the pipeline states so that they make more sense.
  
  Tell us what you think about the new dashboard by dropping us a line on concourse/concourse#1829.
  
  
#### <sub><sup><a name="v370-note-6" href="#v370-note-6">:link:</a></sup></sub> feature

* The [`fly execute`](https://concourse-ci.org/running-tasks.html#fly-execute) command will now default to `-x`, which has been replaced with a new flag, `--include-ignored`, to revert to the old behavior.
  
  In addition, Fly will no longer blow up when trying to execute with an input that doesn't have a `.gitignore`. It will also not blow up if any inputs are files and not directories.
  
  
#### <sub><sup><a name="v370-note-7" href="#v370-note-7">:link:</a></sup></sub> feature

* The ATC will now use a separate database connection pool for the API and the pipeline scheduling work. This will make it so that a bunch of slow API requests can't starve critical functionality.
  
  
#### <sub><sup><a name="v370-note-8" href="#v370-note-8">:link:</a></sup></sub> feature

* Pipeline-provided resource types will no longer fail miserably for a minute or two when they're first configured.
  
  
#### <sub><sup><a name="v370-note-9" href="#v370-note-9">:link:</a></sup></sub> feature

* You can now configure [**`params`**](https://concourse-ci.org/resource-types.html#resource-type-params) on a pipeline resource type, thanks to a PR by @jghiloni! This will enable users to use the [`s3` resource](https://github.com/concourse/s3-resource) with `params: {unpack: true}`, as an alternative to the [`docker-image` resource](https://github.com/concourse/docker-image-resource).
  
  
#### <sub><sup><a name="v370-note-10" href="#v370-note-10">:link:</a></sup></sub> feature

* You can now specify a [**`on_abort`**](https://concourse-ci.org/on-abort-step-hook.html#on_abort) hook on a step or on a job. It will run on abort. 🎉
  
  
#### <sub><sup><a name="v370-note-11" href="#v370-note-11">:link:</a></sup></sub> feature

* The ATC can now be configured with a pure-random worker selection strategy, which may help users affected by our default resource affinity placement, which can result in overloaded workers. This is thanks to a PR by @phillbaker!
  
  To use the random placement strategy, pass `--container-placement-strategy=random` to the `web` command.
  
  
#### <sub><sup><a name="v370-note-12" href="#v370-note-12">:link:</a></sup></sub> feature

* The [`fly jobs`](https://concourse-ci.org/managing-jobs.html#fly-jobs) command now has a column indicating whether any builds are pending or started for each job, thanks to a PR by @rowanjacobs!
  
  
#### <sub><sup><a name="v370-note-13" href="#v370-note-13">:link:</a></sup></sub> feature

* The [`s3` resource](https://github.com/concourse/s3-resource) now supports being configured with a session token, thanks to a PR by @keymon!
  
  
#### <sub><sup><a name="v370-note-14" href="#v370-note-14">:link:</a></sup></sub> feature

* Git repos encrypted with `git-crypt` will now be automatically decrypted by the [`git` resource](https://github.com/concourse/git-resource), thanks to a PR by @dmrschmidt!
  
  
#### <sub><sup><a name="v370-note-15" href="#v370-note-15">:link:</a></sup></sub> feature

* The ATC can now be configured to serve a metrics endpoint for [Prometheus](https://prometheus.io/), thanks to PRs by @TimSimmons and @jmcarp!
  
  
#### <sub><sup><a name="v370-note-16" href="#v370-note-16">:link:</a></sup></sub> feature

* Teams can now have BitBucket-based auth, thanks to a PR by @SHyx0rmZ!
  
  
#### <sub><sup><a name="v370-note-17" href="#v370-note-17">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) can now be configured with a HTTPS proxy, thanks to a PR by @jghiloni!
  
  
#### <sub><sup><a name="v370-note-18" href="#v370-note-18">:link:</a></sup></sub> feature

* Inline task configs are now validated as part of pipeline validation, thanks to a PR by @jmcarp!
  
  
#### <sub><sup><a name="v370-note-19" href="#v370-note-19">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) can now be configured with a Docker username/password for pushing an app using a private repository, thanks to a PR by @elgohr.
  
  
#### <sub><sup><a name="v370-note-20" href="#v370-note-20">:link:</a></sup></sub> feature

* The [`github-release` resource](https://github.com/concourse/github-release-resource) now supports being configured with `insecure: true` to support private GitHub Enterprise installations. For the long-term strategy regarding this, see concourse/concourse#1027.
  
  
#### <sub><sup><a name="v370-note-21" href="#v370-note-21">:link:</a></sup></sub> feature

* The [`semver` resource](https://github.com/concourse/semver-resource) now supports being configured with `skip_ssl_verification: true` to support private S3-compatible blobstores, thanks to a PR by @calebwashburn.
  
  Notice how this note and the prior note have entirely different property names for doing the same thing. Blargh! See concourse/concourse#1027.
  
  
 #### <sub><sup><a name="v370-note-22" href="#v370-note-22">:link:</a></sup></sub> feature

* ATC now has a flag for using k8s secrets when running in a cluster. This change makes using the k8s credential manager an explicit choice when running inside k8s, and also allows you to use a different credential manager when running in a cluster. Thanks for the PR and the patience by @william-tran and @farcaller
  
  


#### <sub><sup><a name="v370-note-23" href="#v370-note-23">:link:</a></sup></sub> fix

* When the ATC is configured with multiple metrics emitters, it will now error, rather than silently picking one, thanks to a PR by @jmcarp.
  
  
#### <sub><sup><a name="v370-note-24" href="#v370-note-24">:link:</a></sup></sub> fix

* Fixed an issue where selecting/copying the build output would also select the timestamp on the left.
  
  
#### <sub><sup><a name="v370-note-25" href="#v370-note-25">:link:</a></sup></sub> fix

* `fly login` will now error if arguments are mistakenly given to it.
  
  
#### <sub><sup><a name="v370-note-26" href="#v370-note-26">:link:</a></sup></sub> fix

* Turns out you could easily spam the build page by holding `T` to trigger multiple builds. We've fixed that now so it only triggers a build once. #YOTO
  
  
#### <sub><sup><a name="v370-note-27" href="#v370-note-27">:link:</a></sup></sub> fix

* Fixed the web UI so that it appropriately shows that you are logged out when your session expires.
  
  
#### <sub><sup><a name="v370-note-28" href="#v370-note-28">:link:</a></sup></sub> fix

* The deprecated [`bosh-deployment` resource](https://github.com/concourse/bosh-deployment-resource) resource now, uh, contains the `bosh` CLI again. Sorry about that. Switch to the [CloudFoundry BOSH deployment resource](https://github.com/cloudfoundry/bosh-deployment-resource) if you can though!
  
  This was fixed by a PR by @Infra-Red. Thanks!
  
  
#### <sub><sup><a name="v370-note-29" href="#v370-note-29">:link:</a></sup></sub> fix

* Fixed an issue with the CredHub integration that made it necessary to configure `--insecure-skip-verify`, thanks to a PR by @aeijdenberg!
  
  
