> **warning:** 
> 
> * There is a known issue with the BOSH release of v3.9.0 where the ATC will fail because function `esc` is not defined concourse/concourse#2029
>   
>   
> 
> * CredHub integration has a bug in this release, please see concourse/concourse#2034 for more details
>   
>   
> 
> 
#### <sub><sup><a name="v390-note-1" href="#v390-note-1">:link:</a></sup></sub> feature

* Certificates can now be automatically propagated from the worker machine into resource containers. This feature took a lot of thought[,](https://i.imgur.com/T6peIq6.png) trial and error, and shaking our fists at each Linux distribution maintainer for having a different approach to how certificates are stored and managed. There's a lot of context for this in concourse/concourse#1027.
  
  Long story short, we wanted a way for certificate management to be done generically across all resources, so that resource authors don't have to keep implementing various forms of `ca_certs`, `insecure_skip_verify`, etc., and things can "just work" securely by default.
  
  This feature is enabled by default for our BOSH distribution. The `concourse` binary now has a `--certs-dir` flag on the `worker` command, which should be given something like `/etc/ssl/certs` or `/etc/pki/tls/certs` depending on your Linux distribution.
  
  See [Certificate Propagation](https://concourse-ci.org/implementing-resource-types.html#resource-certs) for more information.
  
  
#### <sub><sup><a name="v390-note-2" href="#v390-note-2">:link:</a></sup></sub> fix

* The `btrfs` volume driver should now be much more stable. This resolves a (very) long-standing issue that caused us to switch the default to `overlay`, which in turn introduced a known performance regression with privileged tasks and resources (i.e. Docker image building).
  
  If you're feeling the pain of `overlay`, we recommend switching the driver to `btrfs` now and letting us know if you see any issues. Initial feedback is positive. If things are looking good we may switch the default back to `btrfs`.
  
  
#### <sub><sup><a name="v390-note-3" href="#v390-note-3">:link:</a></sup></sub> feature

* Tasks now support [**`inputs.optional`**](https://concourse-ci.org/tasks.html#input-optional) inputs, thanks to a series of PRs by @rosenhouse! This is great for adding optional behavior to tasks and incrementally changing them backwards-compatibly.
  
  
#### <sub><sup><a name="v390-note-4" href="#v390-note-4">:link:</a></sup></sub> feature

* The [CredHub credential manager](https://concourse-ci.org/credhub-credential-manager.html) can now be configured with mutual TLS based authentication.
  
  
#### <sub><sup><a name="v390-note-5" href="#v390-note-5">:link:</a></sup></sub> feature

* Teams can now be renamed via [`fly rename-team`](https://concourse-ci.org/managing-teams.html#fly-rename-team). (...yay!)
  
  
#### <sub><sup><a name="v390-note-6" href="#v390-note-6">:link:</a></sup></sub> fix

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now correctly handles complicated build args, thanks to a PR by @jfmyers9 and @ljfranklin.
  
  
#### <sub><sup><a name="v390-note-7" href="#v390-note-7">:link:</a></sup></sub> feature

* The target will no longer be deleted when running [`fly logout`](https://concourse-ci.org/fly.html#fly-logout) - only its token.
  
  
#### <sub><sup><a name="v390-note-8" href="#v390-note-8">:link:</a></sup></sub> feature

* When viewing a resource, it will now show when it last checked.
  
  
#### <sub><sup><a name="v390-note-9" href="#v390-note-9">:link:</a></sup></sub> fix

* The [`s3` resource](https://github.com/concourse/s3-resource) will now auto-adjust the part size when uploading, so that it can upload files over 50GB. Thanks @ruurdk for the PR!
  
  
#### <sub><sup><a name="v390-note-10" href="#v390-note-10">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now supports loading multiple images at the start via `load_bases` for use in multi-part `Dockerfile`s, thanks to a PR by @krishicks!
  
  
#### <sub><sup><a name="v390-note-11" href="#v390-note-11">:link:</a></sup></sub> fix

* Multi-part `Dockerfile`s with multiple ECR images will now correctly pull each with ECR login support, thanks to a PR by @PeteGoo.
  
  
#### <sub><sup><a name="v390-note-12" href="#v390-note-12">:link:</a></sup></sub> feature

* When using [`fly intercept`](https://concourse-ci.org/builds.html#fly-intercept) with `--url`, the appropriate target will now be auto-detected based on the URL. Thanks @jmcarp for the PR!
  
  
#### <sub><sup><a name="v390-note-13" href="#v390-note-13">:link:</a></sup></sub> fix

* Reduced the throttling when talking to k8s for credential management, thanks to a PR by @william-tran.
  
  
#### <sub><sup><a name="v390-note-14" href="#v390-note-14">:link:</a></sup></sub> feature

* The Prometheus metrics endpoint now includes scheduling and database metrics, thanks to a PR by @TimSimmons!
  
  
#### <sub><sup><a name="v390-note-15" href="#v390-note-15">:link:</a></sup></sub> fix

* The Prometheus metrics endpoint no longer breaks HTTP metrics down by path, because that made the cardinality too damn high. Thanks again @TimSimmons!
  
  
#### <sub><sup><a name="v390-note-16" href="#v390-note-16">:link:</a></sup></sub> feature

* A NewRelic Insights metric emitter has been added, thanks to a PR by @novas0x2a!
  
  
#### <sub><sup><a name="v390-note-17" href="#v390-note-17">:link:</a></sup></sub> feature

* Support for using AWS SSM for credential management has been added, thanks to a PR by @surajbarkale!
  
  
#### <sub><sup><a name="v390-note-18" href="#v390-note-18">:link:</a></sup></sub> feature

* When viewing a pipeline on a teeny tiny display, the obnoxious color indicator legend thingy will no longer prevent you from clicking the stuff below it. Thanks @SwamWithTurtles for the PR!
  
  
#### <sub><sup><a name="v390-note-19" href="#v390-note-19">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now has a `show_app_log` config for tailing the app logs while starting it up. Thanks for the PR, @aeijdenberg!
  
  
#### <sub><sup><a name="v390-note-20" href="#v390-note-20">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) will now propagate `http_proxy` and `https_proxy` when building docker images, thanks to a PR by @boazy!
  
  
#### <sub><sup><a name="v390-note-21" href="#v390-note-21">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) can now be configured with `max_concurrent_downloads` and `max_concurrent_uploads`, thanks to a PR by @drahnr!
  
  
#### <sub><sup><a name="v390-note-22" href="#v390-note-22">:link:</a></sup></sub> feature

* The [`github-release` resource](https://github.com/concourse/github-release-resource) will now produce a `commit_sha` file containing the...commit sha that the release's tag points to. Thanks @defsprite for the PR!
  
  
#### <sub><sup><a name="v390-note-23" href="#v390-note-23">:link:</a></sup></sub> fix

* When contacting CredHub, the configured CA cert is now respected. It was ignored in previous releases. Sorry about that! We've ramped up testing in our pipeline to catch silly things like this in the future.
  
  
#### <sub><sup><a name="v390-note-24" href="#v390-note-24">:link:</a></sup></sub> fix

* Fixed finicky 500 errors when running [`fly volumes`](https://concourse-ci.org/administration.html#fly-volumes) as a result of volumes disappearing while the API walks through and gets their info. The endpoint is still slow, but it at least won't blow up in this case.
  
  
#### <sub><sup><a name="v390-note-25" href="#v390-note-25">:link:</a></sup></sub> fix

* Fixed missing validation for [**`on_success`**](https://concourse-ci.org/jobs.html#job-on-success), [**`on_failure`**](https://concourse-ci.org/jobs.html#job-on-failure), and [**`ensure`**](https://concourse-ci.org/jobs.html#job-ensure) when configured on a job, thanks to a PR by @jmcarp!
  
  
#### <sub><sup><a name="v390-note-26" href="#v390-note-26">:link:</a></sup></sub> fix

* Fixed a subtle timing issue that could result in [`fly watch`](https://concourse-ci.org/builds.html#fly-watch) not finding any builds to watch when given a job.
  
  
