#### <sub><sup><a name="v400-note-1" href="#v400-note-1">:link:</a></sup></sub> feature, breaking

* [![Who am I?](https://concourse-ci.org/images/whoami.gif)](https://www.youtube.com/watch?v=AK2B5ffWR6g)
  
  We've completely redone auth! (Read on before upgrading - this is a huge change and there are some unsupported migration paths.)
  
  In contrast to previous releases of Concourse, *users* are now central to the authentication flow. Instead of logging in as a team, you now log in as a user and can belong to one or more teams. Users can be added to a team by configuring the team's whitelist as described in [Configuring Auth](https://concourse-ci.org/configuring-auth.html).
  
  This is the first step on our march towards full role-based access control. Help us plan that out by checking out the [RFC](https://github.com/concourse/rfcs/pull/6)!
  
  In addition, it is now *much* easier to extend Concourse to support more providers. We're leveraging CoreOS's [Dex](https://github.com/coreos/dex) project for all the moving parts, which already supports a ton of providers (Dex calls them "connectors"). The only delta required for Concourse to support a Dex connector is a tiny bit of glue code in our new [Skymarshal](https://github.com/concourse/skymarshal) component to provide higher-level flags for our CLI.
  
  This was a large change and it was pretty difficult to make backwards-compatible. Here's what's "breaking":
  
  
  
  * There are different flags to pass to the binary distribution, and the BOSH deployment requires manifest changes. Consult [Configuring Auth](https://concourse-ci.org/configuring-auth.html) for more information for the binaries, and the [Concourse BOSH deployment](https://github.com/concourse/concourse-bosh-deployment) repo for BOSH.
    
    
  
  * There is no support for configuring the same provider multiple times (say, multiple GitHub Enterprise instances). The migration will fail when trying to upgrade an instance with teams having different configurations for the same provider.
    
    At the moment, you'll have to deploy multiple Concourse instances. This may be something we can support in the future.
    
    
  
  * There is no longer support for BitBucket auth. Sorry - Dex doesn't support it. :( However we do support generic LDAP, oAuth, and OIDC connectors, which you may be able to use instead.
    
    
  
  * If you have multiple teams configured with the same basic auth username, the migration will fail. This is because "basic auth" is now gone and in its place is local user configuration. Logging in with basic auth is now actually logging in as the configured user, so there can't be multiple.
    
    
  
  * The flags for [`fly set-team`](https://concourse-ci.org/managing-teams.html#fly-set-team) have been split between `set-team` and `concourse web` (because part of the config is now global).
    
    
  
  * You may also need to download and install the latest 4.0.0 `fly` CLI. In the past you would have been able to `fly sync` your way to the latest version of `fly` but the new auth in 4.0.0 will cause the old `fly` to error out.
    
    
  
  You should definitely check for these conditions and take a database backup before attempting the upgrade. In practice, our two largest environments upgraded just fine with no intervention required, but if you're not sure, it can't hurt to be careful.
  
  
#### <sub><sup><a name="v400-note-2" href="#v400-note-2">:link:</a></sup></sub> feature

* Thanks to Dex, we now also support LDAP based auth!
  
  
#### <sub><sup><a name="v400-note-3" href="#v400-note-3">:link:</a></sup></sub> feature

* The [`fly teams`](https://concourse-ci.org/managing-teams.html#fly-teams) command only lists teams of which you are a member (or all teams, if you're a member of the admin team).
  
  You can also pass `-d/--details` to show each team's auth config! This should make it a lot easier to check if the auth setup is correct when someone complains about not being able to log in.
  
  
#### <sub><sup><a name="v400-note-4" href="#v400-note-4">:link:</a></sup></sub> feature, breaking

* Owing to the auth revamp, the [`fly set-team`](https://concourse-ci.org/managing-teams.html#fly-set-team) command no longer takes flags for the provider configuration (so no client IDs/secrets/etc.). This, in combination with the previous feature, should make tweaking the auth config a lot easier.
  
  
#### <sub><sup><a name="v400-note-5" href="#v400-note-5">:link:</a></sup></sub> feature

* The dashboard's influence has taken hold on the web UI! The main page (`/`) now shows the dashboard instead of some random pipeline configured by the first team on the instance. We've also made the dashboard more powerful with pipeline pausing and re-ordering. We hope you like it because we've removed the sidebar from the pipeline view...it's just *cleaner*.
  
  We've also spread the colour scheme to the rest of the UI and changed the font everywhere to Inconsolata.
  
  
#### <sub><sup><a name="v400-note-6" href="#v400-note-6">:link:</a></sup></sub> feature

* We've made significant improvements to the performance of the build page while keeping its functionality exactly the same.
  
  See [this GitHub comment](https://github.com/concourse/concourse/issues/1543#issuecomment-398188077) for the nitty-gritty!
  
  There's still more work that could be done, and we put some planning on the issue, but we figured a 6.5x improvement is a good start so we can get back to big juicy features like *space*. If it's still not fast enough for you, we could really use your help! We're happy to provide guidance for anyone looking to contribute.
  
  
#### <sub><sup><a name="v400-note-7" href="#v400-note-7">:link:</a></sup></sub> fix

* Previously, if a resource was only ever used as an explicit output of a job, it would always show up as black even if it was erroring. It will now show up as orange, like the other resources.
  
  
#### <sub><sup><a name="v400-note-8" href="#v400-note-8">:link:</a></sup></sub> fix

* We've updated some of the messaging in the UI to be less confusing. When viewing a build that has not been made public it'll now say you're not authorized, rather than telling you to log in, only to tell you to log in again, because that didn't change anything.
  
  
#### <sub><sup><a name="v400-note-9" href="#v400-note-9">:link:</a></sup></sub> feature

* When we redid the container lifecycle way back in [**v3.0.0**](https://github.com/concourse/concourse/releases/tag/v3.0.0), one side effect was that containers failed one-off builds would be garbage collected almost immediately, making it pretty difficult to debug (you'd pretty much have to hijack while it was running).
  
  Thanks to a PR from @databus23, there is now a configurable "grace period" after which these containers will be garbage collected! The flag is `--gc-one-off-grace-period` on the `concourse web` command, and it defaults to 5 minutes.
  
  
#### <sub><sup><a name="v400-note-10" href="#v400-note-10">:link:</a></sup></sub> fix

* We fixed a regression with the CredHub integration that caused very high CPU usage on the ATC. In addition, we've bumped our CredHub client to include a fix PRed by @takeyourhatoff which even further reduces CPU usage. Yay!
  
  
#### <sub><sup><a name="v400-note-11" href="#v400-note-11">:link:</a></sup></sub> feature

* The interval on which resource types are checked for new versions can now be set globally via `--resource-type-checking-interval`, or per-resource-type in a pipeline via [**`check_every`**](https://concourse-ci.org/resource-types.html#resource-type-check-every).
  
  
#### <sub><sup><a name="v400-note-12" href="#v400-note-12">:link:</a></sup></sub> fix

* We fixed a couple situations in the UI where jobs or pipelines with spaces in their name would render incorrectly. (Please don't do this though. It looks so weird and just makes the CLI hard to use! We may have to tighten up naming restrictions in the future, and keeping spaces is pretty low priority. Let us know if you have a real good reason though.)
  
  
#### <sub><sup><a name="v400-note-13" href="#v400-note-13">:link:</a></sup></sub> fix

* Clicking the pipeline in the breadcrumb while already on the pipeline page (but viewing a particular group) will now reset the pipeline to the "initial" view. This way it behaves like a normal link.
  
  
#### <sub><sup><a name="v400-note-14" href="#v400-note-14">:link:</a></sup></sub> fix

* Repeated team and pipeline creation and destruction would leave a few tables around: `team_build_events_XXX` and `pipeline_build_events_XXX`. This would cause the database to increase in CPU usage over time.
  
  We now ensure these tables get cleaned up via database triggers on pipeline/team deletion. However, we decided against writing a migration to automatically clean up existing orphaned tables because, well, it felt scary and dangerous.
  
  If you are seeing symptoms of this problem, it should be safe to manually drop the tables that have no corresponding pipeline or team. We just didn't want to be responsible for a migration that had a high chance of data bloodlust. This way it can be your fault instead of ours!
  
  
#### <sub><sup><a name="v400-note-15" href="#v400-note-15">:link:</a></sup></sub> feature

* We've made quite a few optimizations that should take a lot of load off the database. This should improve everything from garbage collection efficiency to web UI response time.
  
  
#### <sub><sup><a name="v400-note-16" href="#v400-note-16">:link:</a></sup></sub> feature

* The Vault credential manager backend can now cache credentials based on their lease duration. This was a big chunk of work and should make Vault operators' lives a bit easier. To enable this feature, pass `--vault-cache` to `concourse web`. Thanks @rfliam for the PR!
  
  As a side note, we're in need of someone to champion the next phase of credential manager support. We've collected feedback from our first (very much MVP) implementation but really need individuals who have experience with each backend to take the next step. See concourse/rfcs#5 for more information!
  
  
#### <sub><sup><a name="v400-note-17" href="#v400-note-17">:link:</a></sup></sub> fix

* When running on Windows, we will no longer shell out to `tar` for performing volume streaming operations, since it seems to be pretty unreliable. A native Go implementation will be used instead, which is a bit slower but much more portable. Thanks for the PR, @ankeesler!
  
  
#### <sub><sup><a name="v400-note-18" href="#v400-note-18">:link:</a></sup></sub> feature

* The [`fly` CLI](https://concourse-ci.org/fly.html) now supports `--json` on most commands to dump info in JSON format, rather than the human-friendly table format.
  
  
#### <sub><sup><a name="v400-note-19" href="#v400-note-19">:link:</a></sup></sub> fix

* Recent versions of Docker introduced an issue where `dockerd` could fail to start if the worker was under load. This resulted in an infinite loop in the [`docker-image` resource](https://github.com/concourse/docker-image-resource).
  
  We've made the resource more resilient to this - it'll detect a failure to start and keep resuscitating `dockerd` until it starts, giving up after 2 minutes.
  
  
#### <sub><sup><a name="v400-note-20" href="#v400-note-20">:link:</a></sup></sub> feature

* The [`s3` resource](https://github.com/concourse/s3-resource) now supports `skip_download: true`, thanks to a PR by @talset!
  
  
#### <sub><sup><a name="v400-note-21" href="#v400-note-21">:link:</a></sup></sub> fix

* The BOSH release now has properties for configuring the DataDog metrics emitter, thanks to @SHyx0rmZ!
  
  
#### <sub><sup><a name="v400-note-22" href="#v400-note-22">:link:</a></sup></sub> feature

* We've split the migration operations out into a separate subcommand: `concourse migrate`. This is just a bit easier to reason about rather than having all the options baked in to the same command that runs the ATC, and also lets you run migrations without passing all the other flags required by `concourse web`.
  
  
#### <sub><sup><a name="v400-note-23" href="#v400-note-23">:link:</a></sup></sub> feature

* The Prometheus metrics will now automatically prune stale workers, thanks to a PR by @databus23!
  
  
#### <sub><sup><a name="v400-note-24" href="#v400-note-24">:link:</a></sup></sub> feature, breaking

* The Prometheus metrics for pipeline scheduling are now counters instead of gauges, thanks to a PR by @databus23!
  
  
#### <sub><sup><a name="v400-note-25" href="#v400-note-25">:link:</a></sup></sub> feature

* There are now metrics emitted for peridoc resource checking, thanks to a PR by @databus23!
  
  
#### <sub><sup><a name="v400-note-26" href="#v400-note-26">:link:</a></sup></sub> fix

* Fixed handling of `no_proxy` in `concourse worker`, thanks to a PR by @databus23!
  
  
#### <sub><sup><a name="v400-note-27" href="#v400-note-27">:link:</a></sup></sub> fix

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now includes support for fetching and extracting `xz` packages in `ADD` commands, thanks to a PR by @et7peho.
  
  
#### <sub><sup><a name="v400-note-28" href="#v400-note-28">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now supports `no_start: true`, thanks to a PR by @klakin-pivotal!
  
  
#### <sub><sup><a name="v400-note-29" href="#v400-note-29">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now has a `tag_file` param which deprecates the old `tag` command which does the same thing. This is in the interest of clearer naming. Thanks for the PR, @ghostsquad!
  
  
