> **warning:** This release unintentionally broke `--postgres-data-source`, which was deprecated back in [**v2.7.2**](https://github.com/concourse/concourse/releases/tag/v2.7.2). We're going to fully remove it in the next release, so now's a good time to switch to the new flags!
> 
> 
#### <sub><sup><a name="v410-note-1" href="#v410-note-1">:link:</a></sup></sub> fix

* Fixed an annoying issue affecting deployments with multiple [`web` node](https://concourse-ci.org/concourse-web.html)s. We were configuring an in-memory store for the Dex auth flow, meaning your login session would only work on one ATC at a time, and could fail partway through the redirect dance.
  
  We now store this state in the same Postgres database that you're already configuring today, so everything should "just work" from here on.
  
  
#### <sub><sup><a name="v410-note-2" href="#v410-note-2">:link:</a></sup></sub> feature

* Task caches can now be cleared via [`fly clear-task-cache`](https://concourse-ci.org/managing-jobs.html#fly-clear-task-cache), thanks to a few PRs by @edtan! This is handy when something has gone terribly wrong with your cache and you need to reset everything. It happens.
  
  
#### <sub><sup><a name="v410-note-3" href="#v410-note-3">:link:</a></sup></sub> feature

* Workers can now be registered with a `--ephemeral` flag. When specified, the worker will be immediately removed once it stalls.
  
  This is useful for situations where you don't have careful control over when and how the worker goes away, for example with preemptible machines or when running with Docker Compose or on a development machine.
  
  Thanks to @tanner-bruce for kicking off the PR for this!
  
  
#### <sub><sup><a name="v410-note-4" href="#v410-note-4">:link:</a></sup></sub> breaking

* We've removed the [`bosh-deployment` resource](https://github.com/concourse/bosh-deployment-resource) from our core set of resources, as it has been deprecated for over a year. Use the [CloudFoundry BOSH deployment resource](https://github.com/cloudfoundry/bosh-deployment-resource) instead! It's much better.
  
  
#### <sub><sup><a name="v410-note-5" href="#v410-note-5">:link:</a></sup></sub> feature

* You can now force an immediate check of a resource type via [`fly check-resource-type`](https://concourse-ci.org/managing-resource-types.html#fly-check-resource-type). This should help shorten feedback loops when testing your own resources types.
  
  Note that the need for this may soon go away if we follow through with [RFC #8](https://github.com/concourse/rfcs/pull/8) which proposes merging [Resource Types](https://concourse-ci.org/resource-types.html) into [Resources](https://concourse-ci.org/resources.html).
  
  
#### <sub><sup><a name="v410-note-6" href="#v410-note-6">:link:</a></sup></sub> fix

* The `concourse/concourse` Docker image now contains the `file` command, which is useful for...working. Without it the `btrfs` volume driver setup would fail. Sorry about that, and thanks to @ElfoLiNk for submitting the PR!
  
  
#### <sub><sup><a name="v410-note-7" href="#v410-note-7">:link:</a></sup></sub> fix

* The `--external-url` and `--peer-url` flags for `concourse web` will now infer defaults that match the configured `--bind-ip` and `--bind-port`, rather than blindly defaulting to `http://127.0.0.1:8080` and breaking when the bind IP/port are changed.
  
  
#### <sub><sup><a name="v410-note-8" href="#v410-note-8">:link:</a></sup></sub> fix

* Inputs that are "new" will now have a yellow icon. This replaces the input background highlighting that was accidentally removed with 4.0's recoloring. We opted to make the icon yellow instead of highlighting the background as we were quickly approaching 50 Shades of Grey.
  
  
#### <sub><sup><a name="v410-note-9" href="#v410-note-9">:link:</a></sup></sub> fix

* We've fixed a scary container snowballing failure mode that could happen when `check` containers failed to create. This was a somewhat hairy bug; see concourse/concourse#2454 for more information.
  
  
#### <sub><sup><a name="v410-note-10" href="#v410-note-10">:link:</a></sup></sub> feature

* Resources can now be pinned across the pipeline as part of the pipeline config by specifying [**`version`**](https://concourse-ci.org/resources.html#resource-version) on the resource definition in the pipeline. This is analogous to setting [**`version`**](https://concourse-ci.org/get-step.html#get-step-version) on every [`get` step](https://concourse-ci.org/get-step.html) that references the resource.
  
  
#### <sub><sup><a name="v410-note-11" href="#v410-note-11">:link:</a></sup></sub> feature

* Pipeline credentials can now be verified via a new `--check-creds` flag available on [`fly set-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-set-pipeline). This will simply try fetching all of them from the configured credential manager, and let you know which ones couldn't be interpolated. Thanks for the PRs, @edtan!
  
  
#### <sub><sup><a name="v410-note-12" href="#v410-note-12">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) is now smart enough to handle shallow clones while still being able to fetch commits that would not normally be included by the configured depth. This should make configuring `depth: 1` safe, so we've removed the condescending warning from the README. Thanks for the PR, @norbertbuchmueller!
  
  
#### <sub><sup><a name="v410-note-13" href="#v410-note-13">:link:</a></sup></sub> feature

* The ATC now exposes an API endpoint for performing a health-check against the configured credential manager, at `/api/v1/info/creds`. It'll propagate whatever information may be useful, depending on your credential manager backend. Note that this endpoint is only accessible by admin users (members of the `main` team).
  
  
#### <sub><sup><a name="v410-note-14" href="#v410-note-14">:link:</a></sup></sub> feature

* When logging in to [`fly` CLI](https://concourse-ci.org/fly.html), if you're already logged in via the web UI it'll just shimmy the existing token over to `fly` rather than requiring you to go through the login flow all over again.
  
  This also fixes the annoying behavior of having to log back in to the web UI whenever logging in to `fly`. Huzzah!
  
  
#### <sub><sup><a name="v410-note-15" href="#v410-note-15">:link:</a></sup></sub> feature

* We gave up on using third-party Go migration libraries and wrote our own. This should make failed migrations a lot easier to troubleshoot and recover from. All of our migrations run in transactions, so there's no more confusing "dirty" state, and failed migrations will record the failure error in the database.
  
  We'll be extracting this package from the ATC soon as a proper library.
  
  
#### <sub><sup><a name="v410-note-16" href="#v410-note-16">:link:</a></sup></sub> feature

* Previously Concourse would allow you to configure arbitrary [**`params`**](https://concourse-ci.org/tasks.html#task-params) in a pipeline, even if the task file itself didn't configure them. This was confusing as it meant the tasks could not be trusted to describe all their required parameters.
  
  Concourse will now emit a warning to the task logs upon noticing this. A future release will turn this into an error. Thanks for the PR, @edtan!
  
  
#### <sub><sup><a name="v410-note-17" href="#v410-note-17">:link:</a></sup></sub> feature

* Searching on the dashboard will now live-update the URL bar, making it easy to copy-paste and share the search with your best friends. Thanks for the PR, @SHyx0rmZ!
  
  
#### <sub><sup><a name="v410-note-18" href="#v410-note-18">:link:</a></sup></sub> fix

* Previously, when searching something on the dashboard that filtered out all the pipelines for a given team, the UI showed messaging that made it look like the team had no pipelines at all, when in reality they just didn't match your search terms. Now the UI will just hide the teams entirely!
  
  
#### <sub><sup><a name="v410-note-19" href="#v410-note-19">:link:</a></sup></sub> feature

* The [`fly validate-pipeline`](https://concourse-ci.org/setting-pipelines.html#fly-validate-pipeline) can now be instructed to print the interpolated pipeline config via `--output`. Thanks for the PR, @henderjm!
  
  
#### <sub><sup><a name="v410-note-20" href="#v410-note-20">:link:</a></sup></sub> feature

* The BOSH release now exposes properties for configuring LDAP auth, thanks to a PR by @JamesClonk!
  
  
#### <sub><sup><a name="v410-note-21" href="#v410-note-21">:link:</a></sup></sub> fix, breaking

* All our auth CA certificate properties were broken - they were `type: certificate` but didn't actually pluck the certificate part off of the property. They're now fixed thanks to a PR by @ArthurHlt.
  
  If this was working for you before, you'll have to change your manifest such that the properties specified conform to the BOSH `certificate` type - so you'll just need to take the existing value and nest it under `certificate:`.
  
  
#### <sub><sup><a name="v410-note-22" href="#v410-note-22">:link:</a></sup></sub> fix

* The TSA will now respect the configured log level for worker heartbeating logs, thanks to a PR by @edtan.
  
  
#### <sub><sup><a name="v410-note-23" href="#v410-note-23">:link:</a></sup></sub> fix

* We got rid of a ton of annoying and chatty logs from the TSA:
  
  
  
  * `closing-channel`
    
    
  
  * `closing-forwarded-tcpip`
    
    
  
  * `waiting-for-tcpip-io`
    
    
  
  * `done-waiting`
    
    
  
  These were useful a long while back as it's fairly tricky to implement a TCP/IP-forwarding SSH server. But now it pretty much works and it was like printing a long line for breathing in and another for breathing out.
  
  
#### <sub><sup><a name="v410-note-24" href="#v410-note-24">:link:</a></sup></sub> fix

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) will now fail more betterly when the `build_args_file` can't be parsed. Thanks @ghostsquad!
  
  
#### <sub><sup><a name="v410-note-25" href="#v410-note-25">:link:</a></sup></sub> fix

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) will now forego starting the Docker daemon if `skip_download: true` is set. Thanks @norbertbuchmueller!
  
  
#### <sub><sup><a name="v410-note-26" href="#v410-note-26">:link:</a></sup></sub> fix

* @petrosagg a few places where Concourse couldn't compile on 32-bit platforms. See concourse/concourse#1379 for more information!
  
  
#### <sub><sup><a name="v410-note-27" href="#v410-note-27">:link:</a></sup></sub> feature

* The [`bosh-io-release` resource](https://github.com/concourse/bosh-io-release-resource) now supports configuring a version `regexp` by which to filter detected versions, thanks to a PR by @dark5un!
  
  
#### <sub><sup><a name="v410-note-28" href="#v410-note-28">:link:</a></sup></sub> feature

* The OIDC auth method now supports being configured with a whitelist of Google hosted domains, thanks to a PR by @rubenv!
  
  
#### <sub><sup><a name="v410-note-29" href="#v410-note-29">:link:</a></sup></sub> feature

* The search field on the dashboard will now live-update the URL, making it easy to share and bookmark pre-set filters. Thanks for the PR, @SHyx0rmZ!
  
  
#### <sub><sup><a name="v410-note-30" href="#v410-note-30">:link:</a></sup></sub> fix

* The [`s3` resource](https://github.com/concourse/s3-resource) can now be used with Dell's EMC ECS object store, thanks to a fix by @adam-power!
  
  
#### <sub><sup><a name="v410-note-31" href="#v410-note-31">:link:</a></sup></sub> fix

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) will now fail with a clearer error when your ECR credentials are incorrect, thanks to a PR by @GrantSheehan!
  
  
#### <sub><sup><a name="v410-note-32" href="#v410-note-32">:link:</a></sup></sub> feature

* The [`docker-image` resource](https://github.com/concourse/docker-image-resource) now supports interpolating the [Concourse-provided env vars](https://concourse-ci.org/implementing-resource-types.html#resource-metadata) in build args, thanks to a PR by @norbertbuchmueller!
  
  
#### <sub><sup><a name="v410-note-33" href="#v410-note-33">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) is now rocking the latest and greatest version of Git LFS, thanks to a PR by @alucillo!
  
  
#### <sub><sup><a name="v410-note-34" href="#v410-note-34">:link:</a></sup></sub> fix

* We went ahead and started using `ON CONFLICT` in more places where we were sorely needing safe upsert mechanics prior to our bump to Postgres 9.5. Database integrity is cool and deserves to be release notes! Don't @ me.
  
  
#### <sub><sup><a name="v410-note-35" href="#v410-note-35">:link:</a></sup></sub> fix

* Building a precompiled BOSH release has been fixed. One of our Windows packages was missing the `exiter.ps1` short-circuit in its spec. Thanks for the PR, @RomRider!
  
  
#### <sub><sup><a name="v410-note-36" href="#v410-note-36">:link:</a></sup></sub> feature

* The [`git` resource](https://github.com/concourse/git-resource) will now emit a short SHA to `.git/short_ref`, which can be useful for dynamic tagging and such. Thanks for the PR, @suda!
  
  
#### <sub><sup><a name="v410-note-37" href="#v410-note-37">:link:</a></sup></sub> feature

* The [`s3` resource](https://github.com/concourse/s3-resource) now supports `skip_download: true` in [**`params`**](https://concourse-ci.org/get-step.html#get-step-params).
  
  
#### <sub><sup><a name="v410-note-38" href="#v410-note-38">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now supports configuring `vars` and `vars_files`, thanks to a PR by @jmcarp!
  
  
#### <sub><sup><a name="v410-note-39" href="#v410-note-39">:link:</a></sup></sub> feature

* The [`cf` resource](https://github.com/concourse/cf-resource) now configures env under each application in the manifest, rather than at the top level (which is deprecated). Thanks for the PR, @jmcarp!
  
  
#### <sub><sup><a name="v410-note-40" href="#v410-note-40">:link:</a></sup></sub> fix

* Clarified the help-text for local user configuration to mention that the password can be in plaintext, and if `bcrypt`ed it must have a minimum cost of 10.
  
  
#### <sub><sup><a name="v410-note-41" href="#v410-note-41">:link:</a></sup></sub> fix

* Fixed a faulty default resulting in borked garbage collection on BOSH deployed workers that are configured to forward through the [TSA](https://concourse-ci.org/architecture.html#component-tsa) (they would try to reach the instance IP rather than `127.0.0.1`).
  
  
#### <sub><sup><a name="v410-note-42" href="#v410-note-42">:link:</a></sup></sub> fix

* Fixed in-place upgrades of binary-deployed workers. Previously registration would fail with a confusing message saying something like "base resource type already exists."
  
  
