![vape naysh](https://concourse-ci.org/images/vapenaysh.png)

#### <sub><sup><a name="v420-note-1" href="#v420-note-1">:link:</a></sup></sub> fix, security

* Fixed a potential information leak: when logged in and viewing a resource from some other team's (exposed) pipeline, you can no longer view the resource's check error, as it may unintentionally have sensitive info in the output. This regressed in [**v4.0.0**](https://github.com/concourse/concourse/releases/tag/v4.0.0).
  
  
#### <sub><sup><a name="v420-note-2" href="#v420-note-2">:link:</a></sup></sub> feature

* The dashboard view will now indicate whether you are a member of each team or whether you're only seeing it because it has exposed pipelines.
  
  
#### <sub><sup><a name="v420-note-3" href="#v420-note-3">:link:</a></sup></sub> feature

* The [`web` node](https://concourse-ci.org/concourse-web.html) can now be configured to periodically emit build logs to a syslog endpoint! This is configured via `--syslog-X` flags on the `concourse web` command. When enabled, build logs will be shipped off in batch as builds complete.
  
  
#### <sub><sup><a name="v420-note-4" href="#v420-note-4">:link:</a></sup></sub> fix, breaking

* In [**v4.1.0**](https://github.com/concourse/concourse/releases/tag/v4.1.0) we accidentally broke support for `--postgres-data-source`. This flag has been deprecated ever since [**v2.7.2**](https://github.com/concourse/concourse/releases/tag/v2.7.2) (over a year ago), so we've opted to finally remove it.
  
  
#### <sub><sup><a name="v420-note-5" href="#v420-note-5">:link:</a></sup></sub> fix

* When we fixed the login bug in [**v4.1.0**](https://github.com/concourse/concourse/releases/tag/v4.1.0) by storing Dex state in the database (rather than in-memory), that effectively made it so that any changes made to auth settings (like local user config, GitHub config, etc) would not take effect.
  
  This was because prior to the fix we were using an in-memory store, so all we had to do before was create all the configs anew, but now that things persist we have to do a comparison and update/remove things that were changed or removed from the flags. Thankfully @edtan noticed this and fixed it in a PR!
  
  
#### <sub><sup><a name="v420-note-6" href="#v420-note-6">:link:</a></sup></sub> fix

* With switching to Dex for auth in [**v4.0.0**](https://github.com/concourse/concourse/releases/tag/v4.0.0) we ended up using the external URL as part of the internal login flow callbacks. This meant it would break if your external URL could not be reached (perhaps it's behind a reverse proxy with auth, or a self-signed-cert, or a firewall).
  
  This is now fixed - the callbacks will go to the internal address only. Sorry for the turbulence! A few folks were stuck on this.
  
  
#### <sub><sup><a name="v420-note-7" href="#v420-note-7">:link:</a></sup></sub> fix

* The [`fly intercept`](https://concourse-ci.org/builds.html#fly-intercept) command will no longer list containers that are still being created and are not yet interceptible, which would lead to an unhelpful `websocket: bad handshake` error.
  
  
#### <sub><sup><a name="v420-note-8" href="#v420-note-8">:link:</a></sup></sub> fix

* Fixed one more instance where logged-in users would get logged out too soon. Specifically, on first login the cookie would expire in 1 hour rather than 24 hours.
  
  The root cause of this was [silly](https://github.com/concourse/skymarshal/commit/f7374f5fa79e0593e16a6382f60a06a2cdb440fa).
  
  
#### <sub><sup><a name="v420-note-9" href="#v420-note-9">:link:</a></sup></sub> fix

* Fixed a potential panic in the 'delete worker' API endpoint, which is used internally as part of the worker draining lifecycle.
  
  
#### <sub><sup><a name="v420-note-10" href="#v420-note-10">:link:</a></sup></sub> fix

* The BOSH release now respects the configured `postgresql.client_cert` property, thanks to a fix by @flavorjones. This broke back in [**v3.3.0**](https://github.com/concourse/concourse/releases/tag/v3.3.0) when we tweaked the type of the property.
  
  
#### <sub><sup><a name="v420-note-11" href="#v420-note-11">:link:</a></sup></sub> fix

* Removed an artificial limit to the garbage collector that was originally to prevent a stampede of work on a single worker. Now that workers garbage-collect themselves, this was no longer necessary, and only slowed down the database side of the garbage collection lifecycle.
  
  
#### <sub><sup><a name="v420-note-12" href="#v420-note-12">:link:</a></sup></sub> fix

* Cleaned up our idempotent process reattaching mumbo-jumbo to not rely on Garden properties which should help quiet down the [`worker` node](https://concourse-ci.org/concourse-worker.html) logs (from when we check for a property that hasn't yet been set).
  
  
#### <sub><sup><a name="v420-note-13" href="#v420-note-13">:link:</a></sup></sub> fix

* Fixed a bug that caused the Vault login retry logic to go into a fast loop if retrying failed for long enough to exceed the maximum retry backoff. Thanks for the PR, @edtan!
  
  
