#### <sub><sup><a name="v540-note-1" href="#v540-note-1">:link:</a></sup></sub> feature, breaking

* We have switched to a more efficient algorithm for streaming volumes between various components of the system - the `web` and `worker` nodes now transmit volumes compressed with the [Zstandard](https://facebook.github.io/zstd/) algorithm rather than [`Gzip`](https://en.wikipedia.org/wiki/Gzip) - `fly` is affected, too (when uploading/downloading artifacts during `fly execute`). We're hoping this will resolve some general complaints of steps being slow to start or appearing to "hang" in clustered environments. **note:** this will require upgrading your workers concourse/concourse#3880.
  
  
#### <sub><sup><a name="v540-note-2" href="#v540-note-2">:link:</a></sup></sub> feature

* Because of the efficiency gained from employing Zstandard compression to volume streaming, the CPU on the web and worker nodes is no longer a limiting factor. Now volumes will be streamed over multiple parallel connections, and we have seen some very exciting improvements in the time taken to initialize build steps. You can see some of our measurements in the discussion on [this issue](https://github.com/concourse/concourse/issues/3992) concourse/concourse#3993.
  
  
#### <sub><sup><a name="v540-note-3" href="#v540-note-3">:link:</a></sup></sub> feature, breaking

* On the build page all steps are now collapsed by default. This means that the build page loads faster, but if you want to watch the logs in real time, you will need to click on the header of the running step concourse/concourse#4058.
  
  
#### <sub><sup><a name="v540-note-4" href="#v540-note-4">:link:</a></sup></sub> feature

* Improved the appearance of the sidebar (re-introduced in [**v5.2.0**](https://github.com/concourse/concourse/releases/tag/v5.2.0)) in response to [user feedback](https://github.com/concourse/concourse/issues/3872). Teams and pipelines are now easier to distinguish, and there are nicely styled tooltips for long items concourse/concourse#4032.
  
  
#### <sub><sup><a name="v540-note-5" href="#v540-note-5">:link:</a></sup></sub> feature

* @maryamklabib optimized the [`pool` resource](https://github.com/concourse/pool-resource) - `check` and `in` scripts will run faster by using shallow cloning concourse/pool-resource#49.
  
  
#### <sub><sup><a name="v540-note-6" href="#v540-note-6">:link:</a></sup></sub> feature

* When you manually trigger a build through the web UI, the 'prep' section at the top of the build page now shows a spinner on the entries marked "discovering new versions of..." while the resource checks are in progress. As the checks resolve, the spinners will become checkmarks, so you'll have a better sense of what might be holding up your build concourse/concourse#3970.
  
  
#### <sub><sup><a name="v540-note-7" href="#v540-note-7">:link:</a></sup></sub> feature

* @deadNightTiger added a [`fly completion`](https://concourse-ci.org/fly.html#fly-completion) subcommand that allows `fly` to output autocompletion for the `bash` and `zsh` shells concourse/concourse#4012.
  
  
#### <sub><sup><a name="v540-note-8" href="#v540-note-8">:link:</a></sup></sub> feature

* When you abort a pending build before it gets scheduled, the build page will now report it as 'cancelled' instead of showing a loading spinner forever concourse/concourse#3922.
  
  
#### <sub><sup><a name="v540-note-9" href="#v540-note-9">:link:</a></sup></sub> feature

* The CSS optimizer used in building the web UI has been upgraded, so the resulting CSS is slightly smaller, which should result in some faster page loads concourse/concourse#4004.
  
  
#### <sub><sup><a name="v540-note-10" href="#v540-note-10">:link:</a></sup></sub> fix

* @cappyzawa fixed an issue where the [`s3` resource](https://github.com/concourse/s3-resource) would break when [`disable_multipart: true`](https://github.com/concourse/s3-resource#source-configuration) was set in the source configuration, and a tracked file was smaller than the minimum upload part size for the configured s3-compatible blobstore concourse/s3-resource#131.
  
  
#### <sub><sup><a name="v540-note-11" href="#v540-note-11">:link:</a></sup></sub> fix

* @robwhitby fixed an [issue](https://github.com/concourse/concourse/issues/4005) where re-checking a resource would cause the metadata from its latest version to be erased concourse/concourse#4028.
  
  
#### <sub><sup><a name="v540-note-12" href="#v540-note-12">:link:</a></sup></sub> fix

* @cappyzawa fixed up `fly` to behave like a sensible Unix tool when passing the `-h` or `--help` flag: it now prints the usage text on `stdout` and returns a successful status code concourse/concourse#4064.
  
  
#### <sub><sup><a name="v540-note-13" href="#v540-note-13">:link:</a></sup></sub> fix

* @cappyzawa fixed a small issue where the `-j` or `--json` flag was not honored when running [`fly get-team`](https://concourse-ci.org/managing-teams.html#fly-get-team) concourse/concourse#4046.
  
  
#### <sub><sup><a name="v540-note-14" href="#v540-note-14">:link:</a></sup></sub> fix

* Fixed a regression found recently involving [momentum based scrolling](https://github.com/concourse/concourse/issues/3956) on build pages on iOS browsers  The fix was also applied to the sidebar and the dashboard concourse/concourse#4050
  
  
#### <sub><sup><a name="v540-note-15" href="#v540-note-15">:link:</a></sup></sub> fix

* The BOSH Backup and Restore job for the database now works properly if you provide your database configuration via a BOSH link. Before, it would always use a hardcoded default if you didn't explicitly specify, causing BOSH links to be ignored concourse/concourse-bosh-release#41.
  
  
#### <sub><sup><a name="v540-note-16" href="#v540-note-16">:link:</a></sup></sub> fix

* Fixed a [bug](https://github.com/concourse/concourse/issues/3803) where, if your local machine is running Mac or Linux and you run `fly execute` with `--input` against a cluster with a mix of Linux and Windows workers, your files could get uploaded to a Windows worker, where ther permission metadata would be stripped off. Now `fly execute` makes sure only to upload user artifacts to workers matching the [`platform`](https://concourse-ci.org/tasks.html#task-platform) of the task being executed concourse/concourse#4066.
  
  
