#### <sub><sup><a name="v550-note-1" href="#v550-note-1">:link:</a></sup></sub> feature

* There is a new [container placement strategy](https://concourse-ci.org/container-placement.html), `limit-active-tasks`. If you specify this strategy, the cluster will maintain a counter of the number of task containers currently running on each worker. Whenever it is time to run a new container, when this strategy is in use, the worker with the fewest active tasks containers will be chosen to run it.
  There is also an optional 'max active tasks per worker' configuration. If this is set to a positive integer, you will see the following behaviour: If all workers are at their active task limit, you will see the message `All workers are busy at the moment, please stand-by.` and the scheduler will re-try a minute later. This pattern will repeat each minute indefinitely, until a worker is available.
  Thanks to @aledeganopix4d for all their hard work on this feature! #4118, #4148, #4208, #4277, #4142, #4221, #4293, #4161, #4315

#### <sub><sup><a name="v550-note-2" href="#v550-note-2">:link:</a></sup></sub> feature

* We have changed our release notes flow! Now, contributors can add draft release notes right in their PRs, by modifying the `release-notes/latest.md` file in the `concourse/concourse` repo #4312.

#### <sub><sup><a name="v550-note-3" href="#v550-note-3">:link:</a></sup></sub> feature

* In the past, [admins](https://concourse-ci.org/user-roles.html#concourse-admin) (owners of the `main` team) had permission to modify the auth configuration for other teams in the same cluster. Now, admins also have full control over pipelines, jobs, resources, builds, etc for all teams. Using `fly`, they can log in to any team on the cluster as though they are an owner #4238, #4273.

#### <sub><sup><a name="v550-note-4" href="#v550-note-4">:link:</a></sup></sub> feature
* We noticed after #4058 (where build steps are collapsed by default) that it wasn't very easy to see failing steps.
  Now a failing step has a red border around its header, an erroring step has an orange border, and a running step has a yellow border. #4164, #4250

#### <sub><sup><a name="v550-note-5" href="#v550-note-5">:link:</a></sup></sub> feature

* On particularly busy clusters, users have observed [metrics events](https://github.com/concourse/concourse/issues/3674) [being dropped](https://github.com/concourse/concourse/issues/3769) due to a full queue #3937. @rudolfv added a configurable buffer size for metrics emission, regardless of your configured emitter. This should allow operators to trade memory pressure on the web nodes for reliability of metric transmission.

#### <sub><sup><a name="v550-note-6" href="#v550-note-6">:link:</a></sup></sub> feature

* @rudolfv also added some features for the special case of InfluxDB metrics. To decrease the request load on InfluxDB, you can configure the number of events to batch into a single InfluxDB request, or you can specify a hardcoded interval at which to emit events, regardless of how many have accumulated #3937.

#### <sub><sup><a name="v550-note-12" href="#v550-note-12">:link:</a></sup></sub> feature

* @nazrhom improved the output of `fly targets` to show an error message in the table if your token for a given target is invalid #4181, #4228.

#### <sub><sup><a name="v550-note-14" href="#v550-note-14">:link:</a></sup></sub> feature

* Concourse admins can now run [`fly active-users`](https://concourse-ci.org/managing-teams.html#fly-active-users) and get a summary of all the users on the cluster, filtering by their last login time (the last 2 months by default) #4096.

#### <sub><sup><a name="v550-note-15" href="#v550-note-15">:link:</a></sup></sub> feature

* @SimonXming fixed up the [worker containers](https://concourse-ci.org/metrics.html#worker%20containers) and [worker volumes](https://concourse-ci.org/metrics.html#worker%20volumes) metrics to include metadata for the tag(s) on the worker and/or the team the worker belongs to (if any) #3037.

#### <sub><sup><a name="v550-note-18" href="#v550-note-18">:link:</a></sup></sub> feature, breaking

* Now requests from the web nodes to the garden servers inside workers (i.e. when creating containers) will time out after 5 minutes. This means that if you have a lot of latency or your garden servers are slow, _your builds and/or resource checks will start to fail_. In general, we have found that failing earlier in cases like this is preferable to hanging forever or failing silently #4137.

#### <sub><sup><a name="v550-note-19" href="#v550-note-19">:link:</a></sup></sub> feature

* Fly has the ability to [autocomplete](https://concourse-ci.org/fly.html#fly-completion) certain configurations for certain shells. @cappyzawa added some more, allowing team and worker names to be autocompleted in fly commands #4087.

#### <sub><sup><a name="v550-note-21" href="#v550-note-21">:link:</a></sup></sub> feature

* @brunocous added an option to skip SSL verification for the git driver on the [semver-resource](https://github.com/concourse/semver-resource) concourse/semver-resource#97.

#### <sub><sup><a name="v550-note-22" href="#v550-note-22">:link:</a></sup></sub> feature

* @mgsolid added a [`pre_without_version`](https://github.com/concourse/semver-resource#parameters) param to the `get` and `put` steps associated to the semver resource. This allows for notating pre-releases without an associated "RC number" (like the `-SNAPSHOT` suffix often seen on pre-release builds managed by Maven) concourse/semver-resource#94.

#### <sub><sup><a name="v550-note-23" href="#v550-note-23">:link:</a></sup></sub> feature

* A [`depth`](https://github.com/concourse/pool-resource#parameters) parameter was added by @maryamklabib to the `get` steps associated with the pool resource. This allows you to get a specified number of commits when fetching a repository concourse/pool-resource#50.

#### <sub><sup><a name="v550-note-24" href="#v550-note-24">:link:</a></sup></sub> feature

* @ThePhilderbeast added proxy support to the Github release resource concourse/github-release-resource#84.

#### <sub><sup><a name="v550-note-25" href="#v550-note-25">:link:</a></sup></sub> feature

* The number of assets listed per release was raised by @oppegard from 30 to 100 on the Github release resource. This will hopefully prevent most issues where the resource would not have the full list of assets to download concourse/github-release-resource#85.

#### <sub><sup><a name="v550-note-26" href="#v550-note-26">:link:</a></sup></sub> feature

* @dprotaso added annotated tag support to the Github release resource concourse/github-release-resource#88, where previously only lightweight tags were supported.

#### <sub><sup><a name="v550-note-27" href="#v550-note-27">:link:</a></sup></sub> feature

* The `evolve` extension has been added to the Mercurial resource by @xavierzwirtz concourse/hg-resource#12.

#### <sub><sup><a name="v550-note-30" href="#v550-note-30">:link:</a></sup></sub> feature

* Build step headers are now sticky, staying at the top of the body on the build page instead of scrolling out of sight as you navigate long logs. This should make it easier to keep track of which step you're inspecting in complicated jobs. #4230

#### <sub><sup><a name="v550-note-31" href="#v550-note-31">:link:</a></sup></sub> feature, breaking

* YAML parsing across the system has been refactored, and in the process has become stricter. There are now some cases (like in [task configs](https://github.com/concourse/concourse/issues/4512)) where you must use an array of hashes when previously a simple hash would be considered valid. Another example is [task_params](https://concourse-ci.org/tasks.html#task-params) where you must use a single YAML mapping instead of a sequence of mappings. When in doubt, refer to the [docs](https://concourse-ci.org/tasks.html). #3505

#### <sub><sup><a name="v550-note-4264" href="#v550-note-4264">:link:</a></sup></sub> fix

* When using the overlay volume driver, you would have to be cautious about preserving your mount table. If it had been cleared, you're volumes would appear empty. Baggageclaim now has the capability to recover missing mounts when the process restarts. #4264

#### <sub><sup><a name="v550-note-7" href="#v550-note-7">:link:</a></sup></sub> fix

* @evanchaoli improved `fly` - when outputting sample commands to the terminal, the CLI is aware of the path from which it is being executed #4284.

#### <sub><sup><a name="v550-note-8" href="#v550-note-8">:link:</a></sup></sub> fix

* The web UI used to [silently break](https://github.com/concourse/concourse/issues/3141) when your token (which includes a potentially-long JSON-encoded string detailing all the teams you are part of and what roles you have on them) was longer than the size of a single cookie (4096 bytes on most browsers!). This limit has been increased 15-fold, which should unblock most users on clusters with a lot of teams #4280.

#### <sub><sup><a name="v550-note-9" href="#v550-note-9">:link:</a></sup></sub> fix

* For the past few releases, the web nodes have allowed themselves to make up to 64 parallel connections to the database, to allow for parallelizing work like GC and scheduling within a single node. @ebilling has configured the web node's tolerance for idle connections to be more lenient: If a node has been using more than 32 of its available connections, up to 32 connections will be allowed to stay idly open. Anecdotally, CPU savings (resulting from less opening/closing of connections) of up to 30% have been observed on web nodes because of this change. Furthermore, the total max connection pool size has been made configurable - this should allow operators to avoid overloading the max connection limit on the database side #4232.

#### <sub><sup><a name="v550-note-10" href="#v550-note-10">:link:</a></sup></sub> fix

* @josecv found and fixed a subtle bug where, if you had a [`try`](https://concourse-ci.org/try-step.html) step and you aborted while the hooked step was running, your whole web node would [crash](https://github.com/concourse/concourse/issues/3989)! Good catch #4252.

#### <sub><sup><a name="v550-note-11" href="#v550-note-11">:link:</a></sup></sub> fix

* @aledeganopix4d fixed an [issue](https://github.com/concourse/concourse/issues/4180) where the logs for a Windows or Darwin worker get populated with irrelevant error messages #4167.

#### <sub><sup><a name="v550-note-13" href="#v550-note-13">:link:</a></sup></sub> fix

* Since introducing [Zstandard compression for volume streaming](https://github.com/concourse/concourse/releases#v540-note-1), we noticed a [new class of baggageclaim errors](https://github.com/concourse/retryhttp/issues/8) saying `http: unexpected EOF reading trailer` cropping up in our own CI environment, so we updated our http clients to retry requests on this error #4233.

#### <sub><sup><a name="v550-note-16" href="#v550-note-16">:link:</a></sup></sub> fix

* Since the [pipeline-operator](https://concourse-ci.org/user-roles.html#team-pipeline-operator-role) role was introduced in [v5.2.0](https://github.com/concourse/concourse/releases#v520-note-3), the tag that appears on the dashboard pages has been improperly formatted. Thanks to @paroxp for noticing and fixing this #4170.

#### <sub><sup><a name="v550-note-17" href="#v550-note-17">:link:</a></sup></sub> fix

* Thanks to @osis for noticing that the [sidebar becomes unclickable](https://github.com/concourse/concourse/issues/4190) when viewing a build for which you are unauthorized to see the logs, and fixing it too! #4201

#### <sub><sup><a name="v550-note-20" href="#v550-note-20">:link:</a></sup></sub> fix

* The `get-team` command for fly will now take `team-name` as an argument for the team name instead of just `team`. Thanks to @cappyzawa for finding this inconsistency! #4086

#### <sub><sup><a name="v550-note-28" href="#v550-note-28">:link:</a></sup></sub> fix

* @xavierzwirtz also fixed `hg.pull` by passing the `sourceUri` in the Mercurial resource. This could fix some issues where Mercurial wasn't saving the full uri in the `hgrc` file concourse/hg-resource#13.

#### <sub><sup><a name="v550-note-29" href="#v550-note-29">:link:</a></sup></sub> fix

* Scrollbars have been given a touch of the Concourse design language. It should no longer use browser defaults. #4355

#### <sub><sup><a name="v550-note-4375" href="#v550-note-4375">:link:</a></sup></sub> fix

* Fixed a (probably-long-standing) issue where the pipelines in the sidebar could [randomly rearrange](https://github.com/concourse/concourse/issues/4346) #4375.
