#### <sub><sup><a name="4583" href="#4583">:link:</a></sup></sub> feature

* We've introduced a `components` table in order to better synchronize all the internal processes that run on the web nodes.

This should help reduce the amount of duplicated work (when running more than 1 ATC), and decrease the load on your database.

There is no configuration required to take advantage of these new improvements.

#### <sub><sup><a name="4535" href="#4535">:link:</a></sup></sub> feature, breaking

* The CloudFoundry auth connector, when configured to authorize users based on CF space membership, will now authorize space auditors and space managers in addition to space developers. This is a breaking change as any teams with CF space-based configuration may grant access to users that they wouldn't have before. #4661

#### <sub><sup><a name="4470" href="#4470">:link:</a></sup></sub> feature, breaking

* All API payloads are now gzipped. This should help save bandwidth and make the web UI load faster. #4470

#### <sub><sup><a name="4480" href="#4480">:link:</a></sup></sub> feature

* @ProvoK added support for a `?title=` query parameter on the pipeline/job badge endpoints! Now you can make it say something other than "build". #4480
  ![badge](https://ci.concourse-ci.org/api/v1/teams/main/pipelines/concourse/badge?title=check%20it%20out)

#### <sub><sup><a name="4518" href="#4518">:link:</a></sup></sub> feature

* @evanchaoli added a feature to stop ATC from attempting to renew Vault leases that are not renewable #4518.

#### <sub><sup><a name="4516" href="#4516">:link:</a></sup></sub> feature

* Add 5 minute timeout for baggageclaim destroy calls #4516.

#### <sub><sup><a name="4334" href="#4334">:link:</a></sup></sub> feature

* @aledeganopix4d added a feature sort pipelines alphabetically #4334.

#### <sub><sup><a name="4494" href="#4494">:link:</a></sup></sub> feature

* API endpoints have been changed to use a single transaction per request, so that they become "all or nothing" instead of holding data in memory while waiting for another connection from the pool. This could lead to snowballing and increased memory usage as requests from the web UI (polling every 5 seconds) piled up. #4494

#### <sub><sup><a name="4448-4588" href="#4448-4588">:link:</a></sup></sub> feature

* You can now pin a resource to different version without unpinning it first #4448, #4588.

#### <sub><sup><a name="4507" href="#4507">:link:</a></sup></sub> fix

* @iamjarvo fixed a [bug](444://github.com/concourse/concourse/issues/4472) where `fly builds` would show the wrong duration for cancelled builds #4507.

#### <sub><sup><a name="4590" href="#4590">:link:</a></sup></sub> feature

* @pnsantos updated the Material Design icon library so now the `concourse-ci` icon is available for resources :tada: #4590

#### <sub><sup><a name="4492" href="#4492">:link:</a></sup></sub> fix

* The `fly format-pipeline` now always produces a formatted pipeline, instead of declining to do so when it was already in the expected format. #4492

#### <sub><sup><a name="4666" href="#4666">:link:</a></sup></sub> fix

* Fixed a regression when running `fly sync` it shows warning of parsing Content-Length and progress bar not showing downloading progress. #4666

#### <sub><sup><a name="v570-3600" href="#v570-3600">:link:</a></sup></sub> feature
  
* Concourse now garbage-collects worker containers and volumes that are not tracked in the database. In some niche cases, it is possible for containers and/or volumes to be created on the worker, but the database (via the web) assumes their creation had failed. If this occurs, these untracked containers can pile up on the worker and use resources. #3600 ensures that they get cleaned appropriately.
 
#### <sub><sup><a name="v570-4516" href="#v570-4516">:link:</a></sup></sub> feature
  
* Add 5 minute timeout for baggageclaim destroy calls. #4516
 
#### <sub><sup><a name="v570-4467" href="#v570-4467">:link:</a></sup></sub> feature
  
* Add 5 minute timeout for worker's garden client http calls. This is primarily to address cases such as destroy which may hang indefinitely causing GC to stop occurring. #4467
 
#### <sub><sup><a name="v570-4562" href="#v570-4562">:link:</a></sup></sub> fix
  
* Transition `failed` state containers to `destroying` resulting in them being GC'ed. This ensures that if web's call to garden to create a container times out, the container is subsequently deleted from garden prior to being deleted from the db. This keeps the web's and worker's state consistent. #4562

#### <sub><sup><a name="4536" href="4536">:link:</a></sup></sub> fix

* Previously, if a worker stalled, the atc would still countdown and remove any 'missing' containers. If the worker ever came back it would still have these containers, but we would not longer be tracking them in the database. Even though we're now garbage collecting these unknown containers, we'd rather that be a last resort. So we [fixed it](https://github.com/concourse/concourse/pull/4536).

#### <sub><sup><a name="4606" href="#4606">:link:</a></sup></sub> feature

* @wagdav updated worker heartbeat log level from `debug` to `info` to reduce extraneous log output for operators #4606

#### <sub><sup><a name="4625" href="#4625">:link:</a></sup></sub> fix

* Fixed a [bug](https://github.com/concourse/concourse/issues/4313) where your dashboard search string would end up with `+`s instead of spaces when logging in. #4265

#### <sub><sup><a name="4636" href="#4636">:link:</a></sup></sub> fix

* Fixed a [bug](https://github.com/concourse/concourse/issues/4493) where the job page would show a loading spinner forever when there were no builds (like before the job had ever been run) #4636.

#### <sub><sup><a name="4630" href="#4630">:link:</a></sup></sub> fix

* Fixed a [bug](https://github.com/concourse/concourse/issues/3921) where the tooltip that says 'new version' on a get step on the build page could be hidden underneath the build header #4630.

#### <sub><sup><a name="4637" href="#4637">:link:</a></sup></sub> fix

* Fixed a [bug](https://github.com/concourse/concourse/issues/3942) where log lines on the build page would have all their timestamps off by one. #4637

#### <sub><sup><a name="4668" href="#4668">:link:</a></sup></sub> fix

* @evanchaoli fixed a [bug](https://github.com/concourse/concourse/issues/4656) where secret redaction incorrectly "redacts" empty string resulting in mangled logs. #4668

#### <sub><sup><a name="v570-4421" href="#v570-4421">:link:</a></sup></sub> feature

* We've restyled the resource metadata displayed in a get step on the build page. It should be easier to read and follow, let us know your critiques on the issue. #4421 #4476

#### <sub><sup><a name="v570-git-resource-273" href="#v570-git-resource-273">:link:</a></sup></sub> fix

* @CliffHoogervorst fixed an [issue](https://github.com/concourse/git-resource/issues/275) in the [git resource](http://github.com/concourse/git-resource), where the version order was not correct when using [`paths`](https://github.com/concourse/git-resource#source-configuration) concourse/git-resource#273.

#### <sub><sup><a name="v570-4548" href="#v570-4548">:link:</a></sup></sub> fix

* @evanchaoli fixed an [issue](https://github.com/concourse/concourse/issues/4545), where [`fly workers`](https://concourse-ci.org/administration.html#fly-workers) would show the wrong age for a worker if that worker was under an hour old #4548.

#### <sub><sup><a name="registry-image-67" href="#registry-image-67">:link:</a></sup></sub> fix

* @hbd fixed a [bug](https://github.com/concourse/registry-image-resource/issues/56) in the [`registry-image` resource](https://github.com/concourse/registry-image-resource) where `get` steps would mysteriously give a 404 error concourse/registry-image-resource#67.

#### <sub><sup><a name="registry-image-69" href="#registry-image-69">:link:</a></sup></sub> fix

* Made the [`registry-image` resource](https://github.com/concourse/registry-image-resource) more resilient - requests that get a 429 (Too Many Requests) from Docker Hub will be retried concourse/registry-image-resource#69.

#### <sub><sup><a name="4425" href="4425">:link:</a></sup></sub> fix

* @Provok fixed an [issue](https://github.com/concourse/concourse/issues/4425), that will help resource authors better understand the errors being returned by concourse.

#### <sub><sup><a name="4599" href="4599">:link:</a></sup></sub> fix

* We fixed an [issue](https://github.com/concourse/concourse/issues/4599), introduced in 5.6.0, where checking a resource would fail if the resource and resource type shared the same name.

* This actually seemed to exacerbate [another issue](https://github.com/concourse/concourse/issues/4546), which we also took the time to fix in #4626.

* You gotta spend money to make money.

#### <sub><sup><a name="4026" href="4026">:link:</a></sup></sub> feature

* @evanchaoli added `minimum_succeeded_builds` to the [build log rentention on the job config](https://concourse-ci.org/jobs.html#job-build-log-retention), that will ensure the build reaper keeps around logs for N successful builds, even if your builds are on a killer losing streak.

#### <sub><sup><a name="4139" href="4139">:link:</a></sup></sub> fix

* We [fixed](https://github.com/concourse/concourse/issues/4139) a migration from 5.4.0. It only affected a small number users that had old unused resources left over from the ancient times. This probably isn't you, so don't worry.

* If you ran into this error `<3`s for being a long time concourse user.


#### <sub><sup><a name="4471" href="4471">:link:</a></sup></sub> fix

* @aledeganopix4d [added](https://github.com/concourse/concourse/pull/4471) some lock types that weren't getting emitted as part of our metrics, so that's neat. You might actually see your lock metrics shoot up because of this, don't panic, it's expected.

#### <sub><sup><a name="4655" href="4655">:link:</a></sup></sub> fix

* @evanchaoli fixed a [bug](https://github.com/concourse/concourse/pull/4655) where vault users, that hadn't configured a shared path, would end up searching the top level `prefix` path for secrets.

#### <sub><sup><a name="4684" href="4684">:link:</a></sup></sub> feature

* @anianz added support for Microsoft login via [dex](https://github.com/dexidp/dex/blob/master/Documentation/connectors/microsoft.md)

#### <sub><sup><a name="4683" href="4683">:link:</a></sup></sub> fix

* @evanchaoli fixed yet another [bug](https://github.com/concourse/concourse/pull/4683) where the builds api would return the wrong builds if you gave it a date newer than the most recent build.