#### <sub><sup><a name="5833" href="#5833">:link:</a></sup></sub> feature

* @mouellet added a way of renaming pipeline resources while preserving version history by updating the resource name (as well as any reference in steps) and specifying its old name as [**`old_name`**](https://concourse-ci.org/resources.html#schema.resource.old_name). After the pipeline has been configured, the `old_name` field can be removed. #5833

#### <sub><sup><a name="5777" href="#5777">:link:</a></sup></sub> feature

* Archived pipelines can be displayed in the web UI via a toggle switch in the top bar. #5777, #5760

#### <sub><sup><a name="5780" href="#5780">:link:</a></sup></sub> fix

* Fixed a regression where builds could be stuck pending forever if an input was pinned by partially specifying a version via the [`version:` on a `get` step](https://concourse-ci.org/jobs.html#schema.step.get-step.version), [`version:` on a resource config](https://concourse-ci.org/resources.html#schema.resource.version) or by running [`fly pin-resource`](https://concourse-ci.org/managing-resources.html#fly-pin-resource). #5780

#### <sub><sup><a name="5758" href="#5758">:link:</a></sup></sub> fix

* @evanchaoli fixed a regression that prevented using both [static vars] and [dynamic vars] simultaneously in a task. #5758

[static vars]: https://concourse-ci.org/vars.html#static-vars
[dynamic vars]: https://concourse-ci.org/vars.html#dynamic-vars

#### <sub><sup><a name="5821" href="#5821">:link:</a></sup></sub> fix

* Pipelines can be re-ordered in the dashboard when filtering. This was a regression introduced in 6.0. #5821

#### <sub><sup><a name="5778" href="#5778">:link:</a></sup></sub> feature

* Style improvements to the sidebar. #5778

#### <sub><sup><a name="5782" href="#5782">:link:</a></sup></sub> fix

* The sidebar can now be expanded in the UI - no more long pipeline names being cut off! #5782

#### <sub><sup><a name="5390" href="#5390">:link:</a></sup></sub> feature

* Add `--include-archived` flag for `fly pipelines` command. #5673

#### <sub><sup><a name="5770" href="#5770">:link:</a></sup></sub> fix

* `fly login` now accepts arbitrarily long tokens when pasting the token manually into the console. Previously, the limit was OS dependent (with OSX having a relatively small maximum length of 1024 characters). This has been a long-standing issue, but it became most noticeable after 6.1.0 which significantly increased the size of tokens. Note that the pasted token is now hidden in the console output. #5770

#### <sub><sup><a name="5390" href="#5390">:link:</a></sup></sub> feature

* Add `--team` flag for `fly set-pipelines` command #5805

#### <sub><sup><a name="5830" href="#5830">:link:</a></sup></sub> fix

* Fix a validation issue where a step can be set with 0 attempts causing the ATC to panic. #5830

#### <sub><sup><a name="5855" href="#5855">:link:</a></sup></sub> fix

* Fix tooltip on pipeline names. PR: #5855

#### <sub><sup><a name="5504" href="#5504">:link:</a></sup></sub> feature

* Refactor existing step structure to simplify introducing new steps. The primary user facing changes are stricter validation and slightly different step validation messages. Previously, fields that were not part of a step wouldn't have failed validation,however, now they will. This will impact stateful actions such as `set-pipeline`. PR: #5504, #5878

#### <sub><sup><a name="5729" href="#5729">:link:</a></sup></sub> feature

* @tlwr updated the `set_pipeline` step to be used across teams. This is 'experimental' for now, please share your feedback in the [thread](https://github.com/concourse/concourse/discussions/5731). PR: #5729

#### <sub><sup><a name="5034" href="#5034">:link:</a></sup></sub> feature

* @evanchaoli added [OPA](https://www.openpolicyagent.org/) integration to Concourse to enable policy enforcement. The [RFC #41](https://github.com/concourse/rfcs/pull/41) for the integration is still in progress so it is considered 'experimental'. PR: #5034

#### <sub><sup><a name="5144" href="#5144">:link:</a></sup></sub> feature

* Add support for task.run.user field in containerd runtime. Issue: #5144 PR: #5704
