#### <sub><sup><a name="v423-note-1" href="#v423-note-1">:link:</a></sup></sub> fix, security

* This release bumps our Garden-runC dependency to v1.18.2 which fixes [CVE 2019-5736](https://nvd.nist.gov/vuln/detail/CVE-2019-5736). **We recommend that you upgrade your Concourse cluster to v4.2.3 to prevent this exploit from occurring.**
  
  Concourse relies on Garden-runC to create containers for executing jobs and resource checks in pipelines. By default, all containers created by Concourse are unprivileged, and should be safe from CVE 2019-5736.
  
  However, if your pipelines configure [`privileged: true`](https://concourse-ci.org/task-step.html#task-step-privileged) on tasks or [`privileged: true`](https://concourse-ci.org/resource-types.html#resource-type-privileged) on resource types in your pipelines, these containers will be privileged, exposing the worker to the attack vector described in CVE 2019-5736. One common example of this is the [`docker-image` resource](https://github.com/concourse/docker-image-resource), which is always privileged.
  
  
#### <sub><sup><a name="v423-note-2" href="#v423-note-2">:link:</a></sup></sub> fix

* The [CF/UAA auth](https://concourse-ci.org/cf-uaa-auth.html) connector has been updated to use the `authorization_endpoint` so that the authentication flow can be completed successfully. Previously, authentication flows would fail whenever a third-party SAML redirect is required.
  
  
